// stordemo.cpp
// 4/4/99
// Driver for demo of storing records in pointer referenced locations
// Ken Brownsey

#include "store.h"
#include <iostream.h>


// PRE	TRUE
// POST	prompts for record which is then stored using KAPRec
//			as its key-address reference
void
Stash_Rec(KAPRec_T &KAPRec) {
	DataRec_T	Rec;

	cout	<< "Please type in record";
	Read_Rec(Rec);
	KAPRec = MakeKAPRec(Rec);
}


// PRE	TRUE
// POST  record at address in KAPRec is retrieved and printed
void
Retrieve_Print_Rec(KAPRec_T KAPRec) {
	DataRec_T Rec;

	Rec = Get_DataRec(KAPRec);
	Write_Rec(Rec);
}


// PRE	TRUE
// POST  key of KAPRec is printed
void
Print_Key(KAPRec_T KAPRec) {

	Write_Key(Get_KAPRecKey(KAPRec));
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	(s)tash a new record  **************\n"
			<<	"***	retrieve and (p)rint record  *******\n"
			<<	"***	print (k)ey of stashed record  *****\n"
			<< "***   e(x)it					   ************\n"
			<< "***   (m)enu						************\n";
}


// PRE	TRUE
// POST	Starts up
void
Initialise() {
	cout <<	"The amazing student record with pointer storage demonstration program\n\n";
}

// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(KAPRec_T &KAPRec) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 's' :	Stash_Rec(KAPRec);
				break;
			case 'p' :  Retrieve_Print_Rec(KAPRec);
				break;
			case 'k' :  Print_Key(KAPRec);
				break;
			case 'm' :	Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
			break;
		}

		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise() {
	cout	<< "That is it !\n";
}


void
main() {
	KAPRec_T KAPRec;

	Initialise();
	Loop(KAPRec);
	Finalise();
}


