// int_arr.cpp
// 4/4/99
// Exercise for simple array operations
// Ken Brownsey


#include <iostream.h>
#include "my_const.h"
#define Max 5

typedef int IntArray_T[Max];
typedef struct {
	IntArray_T	Nums;
	int			NextVacancy;
} IntTable_T;

IntTable_T	Table;


//	PRE 	NOT Q_Full(Tab)
// POST	NewVal is added to Tab
void
Add_Val(int NewVal, IntTable_T &Tab) {
	Tab.Nums[Tab.NextVacancy] = NewVal;
	Tab.NextVacancy++;
}


// PRE	TRUE
// POST 	IF Tab is full RETURNS TRUE
//       ELSE RETURNS FALSE
BOOLEAN
Q_Full(IntTable_T Tab) {
	return(Tab.NextVacancy == Max);
}


// PRE TRUE
// POST 	IF Tab is empty RETURNS TRUE
//       ELSE RETURNS FALSE
BOOLEAN
Q_Empty(IntTable_T Tab) {
	return(Tab.NextVacancy == 0);
}

// PRE	TRUE
// POST	IF Val is in Table RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_Present(int Val, IntTable_T Table) {
	int Index;
	BOOLEAN Q_Found;

	Q_Found = FALSE;

	for (Index =0; (Index < Table.NextVacancy) && !Q_Found; Index++) {
		if (Table.Nums[Index] == Val) {
			Q_Found = TRUE;
		}
	}
	return(Q_Found);
}


// PRE	Val is in Tab
// POST  Val is removed from Tab
void
Delete_Val(int Val, IntTable_T &Table) {
	cout	<< "Delete_Val not yet done\n"
			<< "It looks like being fun\n"
			<< "Shuffle down the ints\n"
			<< "That's last of the hints\n"
			<< "Design, code and watch it run\n";
}


// PRE TRUE
// POST	IF Q_Full(Tab) appropriate message is printed
//			ELSE user is prompted for number to be added to Tab
void
Read_NewVal(IntTable_T &Tab) {
	int	NewVal;

	if (Q_Full(Tab)) {
		cout 	<< "Sorry - table is now full\n";
		cout 	<< "You need to delete some to put new values in \n";
	}
	else {
		cout	<< "Please type in a new value to be added ==> ";
		cin	>> NewVal;
		Add_Val(NewVal, Tab);
	}
}


// PRE TRUE
// POST 	prompts user for value
//			IF value is in Tab prints out message to say so
//       ELSE prints out message to show it is not there
void
Check_Val(IntTable_T Tab) {
	int	Val;

	if (!Q_Empty(Tab)){
		cout 	<< "Please type in a value to check ==> ";
		cin   >> Val;

		if (Q_Present(Val, Tab)) {
			cout	<< Val
					<< " is in the table\n";
		}
		else {
			cout	<< Val
					<< " is not in the table\n";
		}
	}
	else {
		cout	<< ("\nTable is empty - nothing to check\n");
	}
}


// PRE	TRUE
// POST  prompts user for value
//			IF value is in table it is removed and
//				message to show success
//			ELSE message to say that it is not present
void
Remove_Val(IntTable_T &Tab) {

	int	Val;

	if (!Q_Empty(Tab)){
		cout 	<< "Please type in a value to delete ==> ";
		cin   >> Val;

		if (Q_Present(Val, Tab)) {
			Delete_Val(Val, Table);
			cout	<< Val
					<< " has been deleted from the table\n";
		}
		else {
			cout	<< Val
					<< " is not in the table to begin with\n";
		}
	}
	else {
		cout	<< ("\nTable is empty - nothing to delete\n");
	}
}


//	PRE	TRUE
//	POST	IF Tab is not empty all values are printed to screen
//			ELSE message to say that Tab is empty
void
Print_All(IntTable_T Tab) {

	int	Index;

	if (!Q_Empty(Tab)) {
		cout	<< "\n******************\nContents of the table are as follows\n\n";
		for (Index = 0; Index < Tab.NextVacancy; Index++) {
			cout	<< "Value in position "
					<< (Index + 1)
					<< " is ===> "
					<< Tab.Nums[Index]
					<< "\n";
		}
		cout	<< ("\n******************\nThat's all!\n");
	}
	else {
		cout	<< ("\nTable is empty - nothing to print\n\n");
	}
}



//	PRE TRUE
//	POST menu is displayed
void
Menu() {
	cout 	<< "show (m)enu\n";
	cout 	<< "(r)ead in new value\n";
	cout 	<< "(c)heck value is in table\n";
	cout 	<< "r(e)move value from table\n";
	cout 	<< "(p)rint all values in table\n";
	cout  << "e(x)it\n";
}


void
Initialise(IntTable_T &Tab) {
	cout	<< "*********************************\n";
	cout	<< "The great integer storage program\n";
	cout	<< "But part is left for you to fix\n";
   cout	<< "Delete_Val does not work as it should\n";
	cout	<< "*********************************\n";
	Table.NextVacancy = 0;
}


void
Loop(IntTable_T &Tab) {
	char	Option;


	for(Option = 'm'; Option != 'x';) {
		switch (Option) {
			case 'm':
				Menu();
			break;
			case 'r':
				Read_NewVal(Tab);
			break;
			case 'c':
				Check_Val(Tab);
			break;
			case 'e':
				Remove_Val(Tab);
			break;
			case 'p':
				Print_All(Tab);
			break;
			default:
				Menu();
			break;
		}
		cout 	<< "\nPlease type next option ==> ";
		cin   >> Option;
	}
}


void
Finalise(IntTable_T Tab) {
	cout	<< "*********************************\n";
	cout	<< "That's it folks..................\n";
	cout	<< "*********************************";
}


void
main() {
	Initialise(Table);
	Loop(Table);
	Finalise(Table);
}



