// searchdb.cpp
// 6/7/99
// Demo of searching ordered array
// Ken Brownsey


#include <iostream.h>
#include "searchdb.h"
#include <stdlib.h>



//	PRE	Size > 0
//	POST	IF Value present in elements [0..TopLimit] of DB
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE

BOOLEAN
Q_Present(int	Value, SearchArray_T DB, int TopLimit) {
	int Index;

	for(Index = 0; Index <= TopLimit; Index++) {
		if (Value == DB[Index]) {
			return(TRUE);
		}
	}
	return(FALSE);
}



//	PRE	Size > 0
//	POST	DB sorted into ascending order
void
Bubble_Sort(SearchArray_T DB, int Size) {
	int	LoSorted,
			Index;
	int	Temp;
	BOOLEAN	Q_Sorted;

	for(Q_Sorted = FALSE, LoSorted = Size; !Q_Sorted; LoSorted--) {
		Q_Sorted = TRUE;
		for(Index = 0; Index < LoSorted - 1; Index++) {
/*char Dummy;
Print_Array_Interval(DB, 0, Size - 1);
cin	>> Dummy;
cout	<<	"\n";*/
			if (DB[Index] > DB[Index + 1]) {
				Temp = DB[Index];
				DB[Index] = DB[Index + 1];
				DB[Index + 1] = Temp;
				Q_Sorted = FALSE;
			}
		}
	}
}





//	PRE	Size > 0
//	POST	Elements [0..Size - 1] of DB
//			populated with values 1<=Val<=MaxVal
void
Populate_Random_Array(SearchArray_T DB, int Size, int MaxVal) {
	int	Index;
	int	NextVal;

	DB[0] = 1 + rand() % MaxVal;
	for(Index = 1; Index < Size; Index++) {
		NextVal = 1 + rand() % MaxVal;
		for(;Q_Present(NextVal, DB, Index - 1);) {
			NextVal = 1 + rand() % MaxVal;
		}
		DB[Index] = NextVal;
	}
}


//	PRE	Num > 0
int
Find_NumDigits(int Num) {
	int	Index;

	for(Index = 0; Num > 0; Index++) {
		Num = Num / 10;
	}
	return(Index);
}


//	PRE	Hi >= Lo
//	POST	All values in positions [Lo..Hi]
//			are printed to screen
void
Print_Array_Interval(SearchArray_T DB, int Lo, int Hi) {
	#define FieldWidth 3
	int	Index;
	int	SpaceIndex;

	for(Index = 0; Index <= Hi; Index++) {
		if (Index < Lo) {
			for (SpaceIndex = 1; SpaceIndex <= FieldWidth; SpaceIndex++) {
				cout	<<	" ";
			}
		}
		else {
			for (SpaceIndex = 1; SpaceIndex <= FieldWidth - Find_NumDigits(DB[Index]); SpaceIndex++) {
				cout	<<	" ";
			}
			cout	<<	DB[Index];
		}
	}
}

//	PRE	Hi >= Lo
//	POST	All indices from Lo to Hi
//			are printed to screen
void
Print_Array_Indices(SearchArray_T DB, int Lo, int Hi) {
	#define FieldWidth 3
	int	Index;
	int	SpaceIndex;

	for(Index = 0; Index <= Hi; Index++) {
		if (Index < Lo) {
			for (SpaceIndex = 1; SpaceIndex <= FieldWidth; SpaceIndex++) {
				cout	<<	" ";
			}
		}
		else {
			if (Index == 0) {
				for (SpaceIndex = 1; SpaceIndex <= FieldWidth - 1; SpaceIndex++) {
					cout	<<	" ";
				}
			}
			else {
				for (SpaceIndex = 1; SpaceIndex <= FieldWidth - Find_NumDigits(Index); SpaceIndex++) {
					cout	<<	" ";
				}
			}
			cout	<< Index;
		}
	}
}


//	PRE	MaxVal >= Size > 0
// POST	DB' is a sorted array of size Size
//			unique elements in range 1..MaxVal
void
Make_Ordered_RandomDB(SearchArray_T &DB, int	Size, int MaxVal) {

	if (DB != NULL) {
		delete [] DB;
	}
	DB = new int[Size];
	Populate_Random_Array(DB, Size, MaxVal);
	Bubble_Sort(DB, Size);
}







