// srchdemo.cpp
// 6/7/99
// Demo of searching ordered and unordered sequence
// Ken Brownsey

#include <iostream.h>
#include "searchdb.h"
#include <stdlib.h>

SearchArray_T	DataBase = NULL;
int			DBSize = 0;


//	PRE	Size > 0
//	POST	all values in DB
//			are printed to screen
void
Print_All_Values(SearchArray_T DB, int Size) {

	if (Size > 0) {
		cout	<< "\n******************\nValues of the table are as follows\n\n";
		Print_Array_Interval(DB, 0, Size - 1);
		cout	<< ("\n******************\nThat's all the values!\n");
	}
	else {
		cout	<< ("\nDatabase is empty - no keys to print\n\n");
	}
}


//	PRE	TRUE
//	POST	User is prompted for Size of OrdDB
//			IF Size > 0
//				OrdDB contains Size elements in order
//			ELSE
//				message
void
Build_Ordered_RandomDB(SearchArray_T &OrdRandDB, int &Size) {

	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		Make_Ordered_RandomDB(OrdRandDB, Size, 2 * Size);
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}


// PRE 	DB is in ascending key order
// POST 	IF key value is in DB
//				Position' contains value of position of target
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
//			AND Comps contains number of recursive calls
//				from this call
//			AND [First..Last] of Array printed
BOOLEAN
Q_BinSearchPrinting_R(int Target, SearchArray_T Array, int First, int Last, int &Position, int &Comps) {
	int	Middle;

	Comps++;
	if (First > Last) {
		return(FALSE);
	}
	else {
		Print_Array_Indices(Array, First, Last);
		cout	<<	"\n";
		Print_Array_Interval(Array, First, Last);
		cout	<<	"\n";
//		cout	<<	"\n******************\n";
		Middle = (First + Last)/2;
		if (Target == Array[Middle]) {
			Position = Middle;
			return(TRUE);
		}
		else {
			if (Target < Array[Middle]) {
				return(Q_BinSearchPrinting_R(Target, Array, First, Middle - 1, Position, Comps));
			}
			else {
				return(Q_BinSearchPrinting_R(Target, Array, Middle + 1, Last, Position, Comps));
			}
		}
	}
}


// PRE 	DB is in ascending key order
// POST 	prompts user for key value
//			Comps contains number of recursive calls
//				from this call
//			IF key value is in DB
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_BinSearch_R(int Target, SearchArray_T Array, int First, int Last, int &Comps) {
	int	Middle;

	Comps++;
	if (First > Last) {
		return(FALSE);
	}
	else {
		Middle = (First + Last)/2;
		if (Target == Array[Middle]) {
			return(TRUE);
		}
		else {
			if (Target < Array[Middle]) {
				return(Q_BinSearch_R(Target, Array, First, Middle - 1, Comps));
			}
			else {
				return(Q_BinSearch_R(Target, Array, Middle + 1, Last, Comps));
			}
		}
	}
}


void
Do_Bin_Search(SearchArray_T Array, int Size) {
	int	Target;
	int	Position;
	int	Comps;

	cout	<<	"\nType in target element ==> ";
	cin	>>	Target;
	Comps = 0;

	cout	<< "\n";
	if (Q_BinSearchPrinting_R(Target, Array, 0, Size - 1, Position, Comps)) {
		cout	<<	"\nTarget "
				<<	Target
				<<	" is in position "
				<<	Position
				<<	" confirmed as "
				<<	Array[Position]
				<<	"\nThis took "
				<<	Comps
				<<	" calls to the recursive function";
	}
	else {
		cout	<<	"\nTarget "
				<<	Target
				<<	" is not in array ";
	}
}


//	PRE	TRUE
//	POST	User is prompted for
//			maximum possible value MaxVal
//			AND number of searches NumSearches
//			IF MaxVal > 0
//				IF NumSearches > 0
//					MaxVal searches are done on DB
//					AND results displayed
//				ELSE
//					message
//			ELSE
//				message

void
Do_Multiple_Random_Searches(SearchArray_T SearchDB, int Size) {
	int	MaxVal;
	float	NumSearches;
	float	Index;
	int	Target;
	int	Comps;
	float	NumComps;
	float	NumHits;

	cout	<<	"\nPlease input maximum value to be searched for ==> ";
	cin	>> MaxVal;
	if (MaxVal >0) {
		cout	<<	"\nPlease input number of searches to be done ==> ";
		cin	>> NumSearches;
		if (NumSearches > 0) {
			NumHits = 0;
			NumComps = 0;
			for(Index = 1; Index <= NumSearches; Index++) {
				Comps = 0;
				Target = 1 + rand() % MaxVal;
				if (Q_BinSearch_R(Target, SearchDB, 0, Size - 1, Comps)) {
					NumHits++;
				}
				NumComps = NumComps + Comps;
			}

			cout	<<	"\nThere were "
					<<	NumComps
					<<	" comparisons"
					<<	"\nThere were "
					<<	NumHits
					<<	" hits"
					<<	"\nAverage of  "
					<<	NumComps/NumSearches
					<<	" steps";
		}
	}
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<< "***	(p)rint all values        ****************\n"
			<< "***	build (o)rdered random database        ***\n"
			<< "***	do multiple random (s)earches of database \n"
			<< "***	do (b)inary search of database ***********\n"
			<< "***   e(x)it					      ***************\n"
			<< "***   (m)enu						   ***************\n";
}


// PRE	TRUE
// POST	Sets up
void
Initialise(int	&DBSize) {

	DBSize = 0;
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(SearchArray_T DB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'p' :	Print_All_Values(DB, DBSize);
				break;
			case 'o' :	Build_Ordered_RandomDB(DB, DBSize);
				break;
			case 'b' :	Do_Bin_Search(DB, DBSize);
				break;
			case 's' :	Do_Multiple_Random_Searches(DB, DBSize);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(SearchArray_T DB) {
	cout	<< "That is it !\n";
}


void
main() {
	Initialise(DBSize);
	Loop(DataBase);
	Finalise(DataBase);
}
