// srchdemo.cpp
// 6/7/99
// Demo of searching ordered and unordered sequence
// Ken Brownsey

#include <iostream.h>
#include "sortdb.h"
#include <stdlib.h>

SortArray_T	DataBase = NULL;
int			DBSize = 0;


//	PRE	Size > 0
//	POST	all values in DB
//			are printed to screen
void
Print_All_Values(SortArray_T DB, int Size) {

	if (Size > 0) {
		cout	<< "\n******************\nValues of the table are as follows\n\n";
		Print_Array_Interval(DB, 0, Size - 1);
		cout	<< ("\n******************\nThat's all the values!\n");
	}
	else {
		cout	<< ("\nDatabase is empty - no keys to print\n\n");
	}
}


//	PRE	TRUE
//	POST	User is prompted for Size of OrdDB
//			IF Size > 0
//				OrdDB contains Size elements in order
//			ELSE
//				message
void
Build_UnOrdered_RandomDB(SortArray_T &UnOrdRandDB, int &Size) {

	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		Make_RandomArray(UnOrdRandDB, Size, 2 * Size);
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}



//	PRE	Size > 0
//	POST	DB sorted into ascending order
void
Bubble_Sort(SortArray_T DB, int Size, double &Comps, double &Swaps) {
	int	LoSorted,
			Index;
	int	Temp;
	BOOLEAN	Q_Sorted;

	Comps = 0;
	Swaps = 0;
// Comment out next two lines for non-printing run
//	cout	<<	"START   ";
//	Print_Array_Interval(DB, 0, Size - 1);
//	cout	<<	"\n";
	for(Q_Sorted = FALSE, LoSorted = Size; !Q_Sorted; LoSorted--) {
		Q_Sorted = TRUE;
		for(Index = 0; Index < LoSorted - 1; Index++) {
			Comps++;
			if (DB[Index] > DB[Index + 1]) {
				Swaps++;
				Temp = DB[Index];
				DB[Index] = DB[Index + 1];
				DB[Index + 1] = Temp;
				Q_Sorted = FALSE;
				// Comment out next line for non-printing run
		  //		cout	<<	"SWAP    ";
			}
			else {
				// Comment out next line for non-printing run
//				cout	<<	"NO SWAP ";
			}
			// Comment out next four lines for non-printing run
/*			Print_Array_Interval(DB, 0, LoSorted - 1);
			cout	<<	" | ";
			Print_Array_Interval(DB, LoSorted, Size - 1);
			cout	<<	"\n";*/
		}
	}
	// Comment out next two lines for non-printing run
//	 cout	<<	"FINAL   ";
//	 Print_Array_Interval(DB, 0, Size - 1);
}


void
Do_BubbleSort(SortArray_T Array, int Size) {
	double	Swaps;
	double	Comps;

	Comps = 0;
	Swaps = 0;
	Bubble_Sort(Array, Size, Comps, Swaps);
	cout	<<	"\n"
			<<	Comps
			<<	" comparisons were made resulting in "
			<< Swaps
			<<	" swaps\n";
}




// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<< "***	(p)rint all values        ****************\n"
			<< "***	build (u)nordered random database      ***\n"
			<< "***	do (b)ubble sort of database *************\n"
			<< "***   e(x)it					      ***************\n"
			<< "***   (m)enu						   ***************\n";
}


// PRE	TRUE
// POST	Sets up
void
Initialise(int	&DBSize) {

	DBSize = 0;
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(SortArray_T DB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'p' :	Print_All_Values(DB, DBSize);
				break;
			case 'u'	:	Build_UnOrdered_RandomDB(DB, DBSize);
				break;
			case 'b' :	Do_BubbleSort(DB, DBSize);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(SortArray_T DB) {
	cout	<< "That is it !\n";
}


void
main() {
	Initialise(DBSize);
	Loop(DataBase);
	Finalise(DataBase);
}
