// searchdb.h
// 6/7/99
// Linear structure for demo of searching ordered and unordered sequence
// Ken Brownsey

#include "my_const.h"

typedef int	*SortArray_T;

//	PRE	Hi >= Lo
//	POST	All values in positions [Lo..Hi]
//			are printed to screen
//			IF DistPosition >= 0
//				the element in DistPosition is highlighted
//				with a >
void
Print_Array_Interval(SortArray_T Array, int Lo, int Hi, int DistPosition) ;

//	PRE	Hi >= Lo
//	POST	All values in Array
//			are printed to screen
//			AND element at Lo is highlighted with a L
//			AND element at Hi is highlighted with a H
//			AND IF DistPosition >= 0
//					the element at DistPosition is highlighted
//					with a >
void
Print_HighLightedArray(SortArray_T Array, int Lo, int Hi, int MarkedPosition, char Mark, int Size);



//	PRE	MaxVal >= Size > 0
// POST	Array' is an unsorted array of size Size
//			unique elements in range 1..MaxVal
void
Make_UnOrdered_RandomArray(SortArray_T &Array, int	Size, int MaxVal);

//	PRE	MaxVal >= Size > 0
// POST	Array' is a sorted array of size Size
//			unique elements in range 1..MaxVal
void
Make_Ordered_RandomArray(SortArray_T &Array, int	Size, int MaxVal);

//	PRE	MaxVal >= Size > 0
// POST	Array' is a reverse sorted array of size Size
//			unique elements in range 1..MaxVal
void
Make_ReverseOrdered_RandomArray(SortArray_T &Array, int	Size, int MaxVal);

