// sort.cpp
// sort utilities
// Ken Brownsey
// 28/11/98

#include <iostream.h>
#include "my_const.h"
#include "sort.h"
#include "random.h"

// PRE	NOT Q_Empty(Sequence)
// POST	IF Value is in Sequence
//				RETURNS	TRUE
//			ELSE
//				RETURNS  FALSE
Q_Present(int Value, Sequence_T SortedSequence) {

	Go_To_Head(SortedSequence);
	for(;	!Q_At_End(SortedSequence) &&
			(Value > Get_Current(SortedSequence));) {
		Go_To_Next(SortedSequence);
	}
	// EITHER Q_At_End(Sequence)
	// OR NOT Q_At_End(Sequence) AND
	//		Value <= Get_Key(Get_Current(SortedSequence))
	return(Value == Get_Current(SortedSequence));
}



// PRE	TRUE
// POST	Keys of Elements written to screen
void
Write_Keys(Sequence_T Sequence) {

	Go_To_Head(Sequence);
	for(;!Q_At_End(Sequence); ) {
		cout	<<	Get_Key(Get_Current(Sequence))
				<< ' ';
		Go_To_Next(Sequence);
	}
	cout	<<	Get_Key(Get_Current(Sequence))
			<< ' ';
}


// PRE	TRUE
// POST	Keys's elements are random int's >= MinKey and <= MaxKey
//			sorted into ascending order
void
Set_Up_RandomSequence(Sequence_T &Sequence) {
	int	Count;
	int	NewInt;

	Sequence = Create_Sequence();
	for(Count = 0; Count < NumberEls;) {
		NewInt = Make_RandomInt(MinKey, MaxKey);
		if (Q_Empty(Sequence)) {
			Append_After_Current(NewInt, Sequence);
			Count++;
		}
		else {
			if (!Q_KeyPresent(NewInt, Sequence)) {
				Append_After_Current(NewInt, Sequence);
				Count++;
			}
		}
	}
}

// PRE	TRUE
// POST	Number of elments, minimum and maximum
//			key values written to screen
void
Print_SetUpDetails() {
	cout	<<	"\n Number of elemnts is "
			<<	NumberEls
			<< "\n Minimum key value is "
			<< MinKey
			<< "\n Maximum key value is "
			<< MaxKey;
}

//	PRE	Integer >= 0
// POST	RETURNS Nth least significant digit
//	e.g. 	Get_NLSD(1, 758) -> 8
//			Get_NLSD(2, 758) -> 5
//			Get_NLSD(3, 758) -> 7
//			Get_NLSD(4, 758) -> 0
int
Get_NLSD(int N, int Integer) {
	int	Index;
	int	PowerOf10;

	PowerOf10 = 1;
	for (Index = 1; Index < N; Index++) {
		PowerOf10 = PowerOf10 * 10;
	}
	return((Integer/PowerOf10)%10);
}


// PRE	Number >= 0
// POST	RETURNS number of digits in Number
int
Count_Digits(int Number) {

	int	Length;

	for(Length = 1; Number > 9; Length++) {
		Number = Number/10;
	}
	return(Length);
}


