// sortdb.cpp
// 6/7/99
// Radix sort set up
// Ken Brownsey


#include <iostream.h>
#include "sortdb.h"
#include <stdlib.h>


// PRE	TRUE
// POST	IF Value is in DB
//				Position is position in DB
//				RETURNS TRUE
//			ELSE
//				Position is that of last in DB
//				RETURNS FALSE
BOOLEAN
Q_PresentUnOrd(int Value, SortDB_T DB, int &Position) {

	Go_To_Head(DB);
	Position = 1;
	for (; (!Q_At_End(DB)) && (Value != Get_Current(DB));) {
		Go_To_Next(DB);
		Position++;
	}
	// EITHER 	Q_At_End AND Value != Get_Current(DB)
	// OR			Q_At_End AND Value == Get_Current(DB)
	// OR			NOT Q_At_End AND Q_At_End AND Value == Get_Current(DB)
	return(Value == Get_Current(DB));
}



//	PRE	Size > 0
// POST	UnOrdRandDB contains Size distinct
//			integers in the range 1..2 * Size
//			in random order
void
Make_UnOrdered_RandomDB(SortDB_T UnOrdRandDB, int Size) {
	int	Index;
	int	NextVal;
	int	Dummy;

	Append_After_Current(1 + rand() % (2 * Size), UnOrdRandDB);

	for(Index = 2; Index <= Size; Index++) {
		NextVal = 1 + rand() % (2 * Size);
		for(;Q_PresentUnOrd(NextVal, UnOrdRandDB, Dummy);) {
			// try again if latest NextVal is already in
			NextVal = 1 + rand() % (2 * Size);
		}
		Append_After_Current(NextVal, UnOrdRandDB);
		Go_To_Next(UnOrdRandDB);
	}
}


//	PRE	TRUE
//	POST 	Q_Empty(DB)
void
Make_Empty(SortDB_T DB) {

	for(;!Q_Empty(DB);) {
		Delete_Current(DB);
	}
}




