// srchdemo.cpp
// 6/7/99
// Demo of searching ordered and unordered sequence
// Ken Brownsey

#include <iostream.h>
#include "sortdb.h"
#include <stdlib.h>

#define Radix 10

typedef Sequence_T	RadixTable_T[Radix];

//	PRE	Integer >= 0
// POST	RETURNS Nth least significant digit
//	e.g. 	Get_NLSD(1, 758) -> 8
//			Get_NLSD(2, 758) -> 5
//			Get_NLSD(3, 758) -> 7
//			Get_NLSD(4, 758) -> 0
int
Get_NLSD(int N, int Integer) {
	int	Index;
	int	PowerOf10;

	PowerOf10 = 1;
	for (Index = 1; Index < N; Index++) {
		PowerOf10 = PowerOf10 * 10;
	}
	return((Integer/PowerOf10)%10);
}


// PRE	Number >= 0
// POST	RETURNS number of digits in Number
int
Count_Digits(int Number) {

	int	Length;

	for(Length = 1; Number > 9; Length++) {
		Number = Number/10;
	}
	return(Length);
}




//	PRE	TRUE
//	POST	IF DB is not empty all values are printed to screen
void
Print_All_Values(SortDB_T DB) {

	if (!Q_Empty(DB)) {
		Go_To_Head(DB);
		for(;!Q_At_End(DB);) {
			cout	<<	Get_Current(DB);
			Go_To_Next(DB);
			cout	<< " ";
		}
		cout	<<	Get_Current(DB);
	}
}


//	PRE	TRUE
//	POST	User is prompted for Size of OrdDB
//			IF Size > 0
//				OrdDB contains Size elements in order
//			ELSE
//				message
void
Build_UnOrdered_RandomDB(SortDB_T UnOrdRandDB) {
	int	Size;

	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		Make_Empty(UnOrdRandDB);
		Make_UnOrdered_RandomDB(UnOrdRandDB, Size);
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}

// PRE	NOT Q_Empty(Sequence)
// POST	Sequence is in order
void
RadixSort(Sequence_T Sequence) {
//	Sequence_T	RadixTable[Radix];
	RadixTable_T RadixTable;
	int	DigitCount;
	int	MaxKey;
	int	Digit,
			SigDigitPlaceIndex;;
	int	SigDigit;
	Element_T	NextElement;
	char	Dummy;

	Go_To_Head(Sequence);
	for (MaxKey = Get_Current(Sequence); !Q_At_End(Sequence); ) {
		Go_To_Next(Sequence);
		if (Get_Current(Sequence) > MaxKey) {
			MaxKey = Get_Current(Sequence);
		}
	}
	DigitCount = Count_Digits(MaxKey);

	for (Digit = 0; Digit < Radix; Digit++) {
		RadixTable [Digit] = Create_Sequence();
	}

	for (SigDigitPlaceIndex = 1; SigDigitPlaceIndex <= DigitCount; SigDigitPlaceIndex++) {
		cout	<<	"\nPress any key to continue";
		cin.get(Dummy);
		cout	<<	"\nSequence is ";
		Print_All_Values(Sequence);
		cout	<<	"\nSignificant digit place index is "
				<<	SigDigitPlaceIndex
				<<	"\n";
		Go_To_Head(Sequence);
		for (;!Q_Empty(Sequence);) {
			NextElement = Get_Current(Sequence);
			Delete_Current(Sequence);
			SigDigit = Get_NLSD(SigDigitPlaceIndex, NextElement);
			Append_After_Current(NextElement, RadixTable[SigDigit]);
			if (!Q_At_End(RadixTable[SigDigit])) {
				Go_To_Next(RadixTable[SigDigit]);
			}
		}
		//	Q_Empty(Sequence)
		for (Digit = 0; Digit < Radix; Digit++) {
			cout	<<	"\nsubsequence "
					<<	Digit
					<<	" is ";
			Print_All_Values(RadixTable[Digit]);
			Go_To_Head(RadixTable[Digit]);
			for (;!Q_Empty(RadixTable[Digit]);) {
				NextElement = Get_Current(RadixTable[Digit]);
				Delete_Current(RadixTable[Digit]);
				Append_After_Current(NextElement, Sequence);
				if (!Q_At_End(Sequence)) {
					Go_To_Next(Sequence);
				}
			}
		}
	}
	cout	<<	"\n\n\nSorted sequence is ";
	Print_All_Values(Sequence);

	for (Digit = 0; Digit < Radix; Digit++) {
		Free_Sequence(RadixTable [Digit]);
	}
}


//	PRE	TRUE
//	POST	User is prompted for
//			maximum possible value MaxVal
//			AND number of searches NumSortes
//			IF MaxVal > 0
//				IF NumSortes > 0
//					MaxVal searches are done on DB
//					AND results displayed
//				ELSE
//					message
//			ELSE
//				message

void
Do_Multiple_Random_Sorts(SortDB_T SortDB) {

	cout	<<	"\nNow for multiples of the radix sort"
			<<	"\nMake sure the basic idea you have caught"
			<<	"\nIt will then be easy"
			<< "\nYour code is not wheezy"
			<<	"\nTo get it working quite just as it ought";
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<< "***	(p)rint all values        ****************\n"
			<< "***	build (u)nordered random database     ****\n"
			<< "***	(r)adix sort                          ****\n"
			<< "***	do multiple random (s)earches of database \n"
			<< "***	make database (e)mpty  *******************\n"
			<< "***   e(x)it					      ***************\n"
			<< "***   (m)enu						   ***************\n";
}


// PRE	TRUE
// POST	Clears up
void
Initialise(SortDB_T *DB_Ptr) {

	(*DB_Ptr) = Create_Sequence();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(SortDB_T DB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'p' :	Print_All_Values(DB);
				break;
			case 'u' :	Build_UnOrdered_RandomDB(DB);
				break;
			case 'r' :	RadixSort(DB);
				break;
			case 's' :	Do_Multiple_Random_Sorts(DB);
				break;
			case 'e' :	Make_Empty(DB);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(SortDB_T DB) {
	Make_Empty(DB);
	Free_Sequence(DB);
	cout	<< "That is it !\n";
}


void
main() {
	SortDB_T	DataBase;

	Initialise(&DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}
