// searchdb.cpp
// 6/7/99
// Linear structure for demo of searching ordered and unordered sequence
// Ken Brownsey


#include <iostream.h>
#include "searchdb.h"
#include <stdlib.h>
#include <fstream.h>
#include "rd_str.h"

//	PRE	Keys in DB are in order
// POST	DB' = DB with NewRec added
//       AND keys in DB' are in order
void
Add_Value(DataRec_T Value, SearchDB_T DB) {
	KAPRec_T	NewKAPRec;

	NewKAPRec = Make_KAPRec(Value);
	if (Q_Empty(DB)) {
		Append_After_Current(NewKAPRec, DB);
	}
	else {
		Go_To_Head(DB);

		for (; (!Q_At_End(DB)) && (Get_Key(Value) > Get_KAPRecKey(Get_Current(DB)));) {
			Go_To_Next(DB);
		}
		// EITHER 	Q_At_End AND Get_Key(Value) > Get_KAPRecKey(Get_Current(DB))
		// OR			Q_At_End AND Get_Key(Value) <= Get_KAPRecKey(Get_Current(DB))
		// OR			NOT Q_At_End AND Q_At_End AND Get_Key(Value) <= Get_KAPRecKey(Get_Current(DB))
		if (Get_Key(Value) <= Get_KAPRecKey(Get_Current(DB))) {
			Insert_Before_Current(NewKAPRec, DB);
		}
		else {
			Append_After_Current(NewKAPRec, DB);
		}
	}
}


// PRE	DB is in ascending key order
// POST	IF Value is in DB
//				Position is position in DB
//				AND key of current record in DB'
//              = Key
//				RETURNS TRUE
//			ELSE
//				IF at least one value in DB > Value
//					Position is that of the
//					next largest to Value
//				ELSE
//					Position is that of last in DB
//					RETURNS FALSE
BOOLEAN
Q_PresentOrd(Key_T Key, SearchDB_T DB, int &Position) {

	Go_To_Head(DB);
	Position = 1;
	for (; (!Q_At_End(DB)) && (Key > Get_KAPRecKey(Get_Current(DB)));) {
		Go_To_Next(DB);
		Position++;
	}
	// EITHER 	Q_At_End AND Get_Key(Value) > Get_KAPRecKey(Get_Current(DB))
	// OR			Q_At_End AND Get_Key(Value) <= Get_KAPRecKey(Get_Current(DB))
	// OR			NOT Q_At_End AND Q_At_End AND Get_Key(Value) <= Get_KAPRecKey(Get_Current(DB))
	return(Key == Get_KAPRecKey(Get_Current(DB)));
}



//	PRE	TRUE
//	POST 	Q_Empty(DB)
void
Make_Empty(SearchDB_T DB) {

	for(;!Q_Empty(DB);) {
		Delete_Current(DB);
	}
}



// PRE	TRUE
// POST	User is prompted for filename
//			IF this is a file of Element_T's
//				these are loaded into DBase
//				except for those already there
//				which are printed with appropriate message
void
Load_DB_From_File(SearchDB_T SearchDB) {
	char	*FName;
	ifstream	InFile;
	DataRec_T NextRec;
	BOOLEAN	Q_OKRead;
	int	DummyPosition;

	cout	<< "\nPlease type name of file to load from ==> ";
	FName = Read_String();
	InFile.open(FName, ios::in);
	if (InFile == NULL) {
		cout	<< "\n\nError - cannot open "
				<< FName
				<< "\n\n";
	}
	else {
		cout	<< "\nLoading records from "
				<< FName;
		for(;!InFile.eof();) {
			NextRec = Read_Rec_From_File(InFile, Q_OKRead);
			if (Q_OKRead) {
				if (!InFile.eof()) {
					if (!Q_PresentOrd(Get_Key(NextRec), SearchDB, DummyPosition)) {
						cout	<< "\nRecord ==> ";
						Write_Rec(NextRec);
						Add_Value(NextRec, SearchDB);
					}
					else {
						cout	<< "\nRecord with key ";
						Write_Key(Get_Key(NextRec));
						cout	<< " is already in database";
					}
				}
			}
			else {
				cout	<<	"\nThere is a problem reading from file "
						<<	FName
						<<	"\n\n";
			}
		}
	}
}


