// searchdb.cpp
// 6/7/99
// Linear structure for demo of searching ordered and unordered sequence
// Ken Brownsey


#include <iostream.h>
#include "searchdb.h"
#include <stdlib.h>

//	PRE	Keys in DB are in order
// POST	DB' = DB with NewRec added
//       AND keys in DB' are in order
void
Add_Value(int Value, SearchDB_T DB) {

	if (Q_Empty(DB)) {
		Append_After_Current(Value, DB);
	}
	else {
		Go_To_Head(DB);

		for (; (!Q_At_End(DB)) && (Value > Get_Current(DB));) {
			Go_To_Next(DB);
		}
		// EITHER 	Q_At_End AND Value > Get_Current(DB)
		// OR			Q_At_End AND Value <= Get_Current(DB)
		// OR			NOT Q_At_End AND Q_At_End AND Value <= Get_Current(DB)
		if (Value <= Get_Current(DB)) {
			Insert_Before_Current(Value, DB);
		}
		else {
			Append_After_Current(Value, DB);
		}
	}
}


// PRE	TRUE
// POST	IF Value is in DB
//				Position is position of Value in DB
//				RETURNS TRUE
//			ELSE
//				Position' is that of last in DB
//				AND	Q_At_End(DB')
//				RETURNS FALSE
BOOLEAN
Q_PresentUnOrd(int Value, SearchDB_T DB, int &Position) {

	Go_To_Head(DB);
	for (Position = 1; (!Q_At_End(DB)) && (Value != Get_Current(DB));Position++) {
		Go_To_Next(DB);
	}
	// EITHER 	Q_At_End AND Value != Get_Current(DB)
	// OR			Q_At_End AND Value == Get_Current(DB)
	// OR			NOT Q_At_End AND Q_At_End AND Value == Get_Current(DB)
	if (Value == Get_Current(DB)) {
		return(TRUE);
	}
	else {
		return(FALSE);
	}
}


//	PRE	Num > 0
//	POST	RETURNS number of digits in Num
int
Find_NumDigits(int Num) {
	int	Index;

	for(Index = 0; Num > 0; Index++) {
		Num = Num / 10;
	}
	return(Index);
}



//	PRE	Size > 0
// POST	UnOrdRandDB contains Size distinct
//			integers in the range 1..MaxVal
//			in random order
void
Make_UnOrdered_RandomDB(SearchDB_T UnOrdRandDB, int Size, int &MaxVal) {
	int	Index;
	int	NextVal;
	int	Dummy;

	Append_After_Current(1 + rand() % (2 * Size), UnOrdRandDB);
	MaxVal = 2*Size;

	for(Index = 2; Index <= Size; Index++) {
		NextVal = 1 + rand() % MaxVal;
		for(;Q_PresentUnOrd(NextVal, UnOrdRandDB, Dummy);) {
			// try again if latest NextVal is already in
			NextVal = 1 + rand() % MaxVal;
		}
		Append_After_Current(NextVal, UnOrdRandDB);
		Go_To_Next(UnOrdRandDB);
	}
}


//	PRE	TRUE
//	POST 	Q_Empty(DB)
void
Make_Empty(SearchDB_T DB) {

	for(;!Q_Empty(DB);) {
		Delete_Current(DB);
	}
}


//	PRE	TRUE
//	POST	RETURNS number of elements in DB
int
Get_Size(SearchDB_T DB) {
	int	Size;

	Size = 0;
	if (!Q_Empty(DB)) {
		Go_To_Head(DB);
		Size++;
		for(;!Q_At_End(DB);) {
			Go_To_Next(DB);
			Size++;
		}
	}
	return(Size);
}




