// srchdemo.cpp
// 6/7/99
// Demo of searching ordered and unordered sequence
// Ken Brownsey

#include <iostream.h>
#include "searchdb.h"
#include <stdlib.h>

BOOLEAN	Q_Ordered;

// PRE 	DB is in ascending key order
// POST 	prompts user for key value
//			IF key value is in DB
//				prints out message to say so
//       ELSE prints out
//				message to show it is not there
void
Check_ValueOrd(SearchDB_T DB) {
	int 	Value;
	int	Position;

	if (!Q_Empty(DB)){
		cout 	<< "Please type in value to check ==> ";
		cin	>> Value;

		if (Q_PresentOrd(Value, DB, Position)) {
			cout	<< "Value  "
					<<	Value
					<< " is in the table at position "
					<<	Position
					<<	"\n";
		}
		else {
			cout	<< "There is no value "
					<<	Value
					<< " in the table\n"
					<< "Search stopped at position "
					<<	Position
					<<	"\n";
		}
	}
	else {
		cout	<< ("\nDB is empty - nothing to check\n");
	}
}


// PRE 	TRUE
// POST 	prompts user for key value
//			IF key value is in DB
//				prints out message to say so
//       ELSE prints out
//				message to show it is not there
void
Check_ValueUnOrd(SearchDB_T DB) {
	int 	Value;
	int	Position;

	if (!Q_Empty(DB)){
		cout 	<< "Please type in key of value to check ==> ";
		cin	>> Value;

		if (Q_PresentUnOrd(Value, DB, Position)) {
			cout	<< "Value  "
					<<	Value
					<< " is in the table at position "
					<<	Position
					<<	"\n";
		}
		else {
			cout	<< "There is no value "
					<<	Value
					<< " in the table\n"
					<< "Search stopped at position "
					<<	Position
					<<	"\n";
		}
	}
	else {
		cout	<< ("\nDB is empty - nothing to check\n");
	}
}


//	PRE	TRUE
//	POST	IF DB is not empty all values are printed to screen
//			ELSE message to say that DB is empty
void
Print_All_Values(SearchDB_T DB) {

	if (!Q_Empty(DB)) {
		cout	<< "\n******************\nValues of the table are as follows\n\n";
		Go_To_Head(DB);
		for(;!Q_At_End(DB);) {
			cout	<<	Get_Current(DB);
			Go_To_Next(DB);
			cout	<< " ";
		}
		cout	<<	Get_Current(DB);
		cout	<< ("\n******************\nThat's all the values!\n");
	}
	else {
		cout	<< ("\nDatabase is empty - no keys to print\n\n");
	}
}


//	PRE	TRUE
//	POST	User is prompted for Size of OrdDB
//			IF Size > 0
//				OrdDB contains Size elements in order
//			ELSE
//				message
void
Build_Ordered_RandomDB(SearchDB_T OrdRandDB) {
	int	Size;

	Make_Empty(OrdRandDB);
	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		Make_Ordered_RandomDB(OrdRandDB, Size);
		Q_Ordered = TRUE;
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}


//	PRE	TRUE
//	POST	User is prompted for Size of OrdDB
//			IF Size > 0
//				OrdDB contains Size elements in order
//			ELSE
//				message
void
Build_UnOrdered_RandomDB(SearchDB_T UnOrdRandDB) {
	int	Size;

	Make_Empty(UnOrdRandDB);
	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		Make_UnOrdered_RandomDB(UnOrdRandDB, Size);
		Q_Ordered = FALSE;
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}


//	PRE	TRUE
//	POST	User is prompted for
//			maximum possible value MaxVal
//			AND number of searches NumSearches
//			IF MaxVal > 0
//				IF NumSearches > 0
//					MaxVal searches are done on DB
//					AND results displayed
//				ELSE
//					message
//			ELSE
//				message
void
Do_Multiple_Random_Searches(SearchDB_T SearchDB) {
	int	MaxVal;
	float	NumSearches;
	float	Index;
	int	Target;
	int	Position;
	float	NumComps;
	float	NumHits;

	cout	<<	"\nPlease input maximum value to be searched for ==> ";
	cin	>> MaxVal;
	if (MaxVal >0) {
		cout	<<	"\nPlease input number of searches to be done ==> ";
		cin	>> NumSearches;
		if (NumSearches > 0) {
			NumComps = 0;
			NumHits = 0;
			for(Index = 1; Index <= NumSearches; Index++) {
				Target = 1 + rand() % MaxVal;
				if (Q_Ordered) {
					if (Q_PresentOrd(Target, SearchDB, Position)) {
						NumHits++;
					}
				}
				else {
					if (Q_PresentUnOrd(Target, SearchDB, Position)) {
						NumHits++;
					}
				}
				NumComps = NumComps + Position;
			}

			cout	<<	"\nThere were "
					<<	NumComps
					<<	" comparisons"
					<<	"\nThere were "
					<<	NumHits
					<<	" hits"
					<<	"\nAverage of  "
					<<	NumComps/NumSearches
					<<	" comparisons";
		}
	}
}
   

// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	put new record into (k)ey order **********\n"
			<< "***	(p)rint all values        ****************\n"
			<< "***	(c)heck key - ordered database      ******\n"
			<< "***	c(h)eck key - unordered database       ***\n"
			<< "***	build (o)rdered random database        ***\n"
			<< "***	build (u)nordered random database     ****\n"
			<< "***	do multiple random (s)earches of database \n"
			<< "***	make database (e)mpty  *******************\n"
			<< "***   e(x)it					      ***************\n"
			<< "***   (m)enu						   ***************\n";
}


// PRE	TRUE
// POST	Clears up
void
Initialise(SearchDB_T *DB_Ptr) {

	(*DB_Ptr) = Create_Sequence();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(SearchDB_T DB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'p' :	Print_All_Values(DB);
				break;
			case 'c' :	Check_ValueOrd(DB);
				break;
			case 'h' :	Check_ValueUnOrd(DB);
				break;
			case 'o' :	Build_Ordered_RandomDB(DB);
				break;
			case 'u' :	Build_UnOrdered_RandomDB(DB);
				break;
			case 's' :	Do_Multiple_Random_Searches(DB);
				break;
			case 'e' :	Make_Empty(DB);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(SearchDB_T DB) {
	Make_Empty(DB);
	Free_Sequence(DB);
	cout	<< "That is it !\n";
}


void
main() {
	SearchDB_T	DataBase;

	Initialise(&DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}
