//sortdemo.cpp
// 6/7/99
//	Demo of MergeSort
// Ken Brownsey

#include <iostream.h>
#include "sortdb.h"
#include <stdlib.h>

#define NoPrint -1


SortArray_T	DataBase = NULL,
				TempArray;
int			DBSize = 0;


//	PRE	TRUE
//	POST	User is prompted for Size of OrdDB
//			if Size > 0
//				OrdDB contains Size elements unordered
//			else
//				message
void
Build_UnOrdered_RandomDB(SortArray_T &UnOrdRandDB, SortArray_T &TempArray, int &Size) {

	cout	<< "\nPlease type in number of elements ==> ";
	cin	>>	Size;
	if (Size > 0 ) {
		Make_UnOrdered_RandomArray(UnOrdRandDB, TempArray, Size, 2 * Size);
	}
	else {
		cout	<<	"\n"
				<<	Size
				<<	" is less than 0";
	}
}



// PRE	Elements SortArray[LeftLo..LeftHi] are in ascending order
//			Elements SortArray[RightLo..RightHi] are in ascending order
//	POST	Elements SortArray[LefttLo..RightHi] are in ascending order
void
Merge(	SortArray_T Array, SortArray_T TempArray, int LeftLo, int LeftHi, int RightLo, int RightHi, int DBSize) {
	int	Index,
			Index1,
			Index2;

	Print_HighLightedArray(Array, LeftLo, RightLo, NoPrint, ' ', DBSize);
	cout	<<	"\n";

	for(Index1 = LeftLo, Index2 = RightLo;(Index1 <= LeftHi) && (Index2 <= RightHi);) {
		if (Array[Index1] < Array[Index2]) {
			TempArray[Index] = Array[Index1];
			Index1++;
		}
		else {
			TempArray[Index] = Array[Index2];
			Index2++;
		}
		Index++;
	}

	for(;(Index1 <= LeftHi);) {
		TempArray[Index] = Array[Index1];
		Index1++;
		Index++;
	}

	for(;(Index2 <= RightHi);) {
		TempArray[Index] = Array[Index2];
		Index2++;
		Index++;
	}

	for(Index = LeftLo; Index <= RightHi; Index++) {
		Array[Index] =  TempArray[Index];
	}
}



void
MergeSort_R(SortArray_T Array, SortArray_T TempArray, int Lo, int Hi, int DBSize) {
	int	Middle;

	if (Lo < Hi) {
		Middle = (Lo + Hi) / 2;
		MergeSort_R(Array, TempArray, Lo, Middle, DBSize);
		MergeSort_R(Array, TempArray, Middle + 1, Hi, DBSize);
		Merge(Array, TempArray, Lo, Middle, Middle + 1, Hi, DBSize);
	}
}



//	PRE	TRUE
//	POST	Array' is MergeSorted
void
Do_MergeSort(SortArray_T Array, SortArray_T TempArray, int Size) {
	char	Response;

	if	(Size > 0) {
		MergeSort_R(Array, TempArray, 0, Size - 1, Size);
		Print_HighLightedArray(Array, NoPrint, NoPrint, NoPrint, ' ', DBSize);
	}
	else {
		cout	<< "\nSize must be greater than 0 - no MergeSort to do !";
	}
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<< "***	(p)rint all values        ****************\n"
			<< "***	build (u)nordered random database        ***\n"
			<< "***	do multiple random (s)earches of database \n"
			<< "***	mer(g)esort database ********************\n"
			<< "***   e(x)it					      ***************\n"
			<< "***   (m)enu						   ***************\n";
}


// PRE	TRUE
// POST	Sets up
void
Initialise(int	&DBSize) {

	DBSize = 0;
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(SortArray_T DB, SortArray_T TempDB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'p' :	Print_HighLightedArray(DB, NoPrint, NoPrint, NoPrint, ' ', DBSize);
				break;
			case 'u' :	Build_UnOrdered_RandomDB(DB, TempDB, DBSize);
				break;
			case 'g' :	Do_MergeSort(DB, TempDB, DBSize);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(SortArray_T DB) {
	cout	<< "That is it !\n";
}


void
main() {
	Initialise(DBSize);
	Loop(DataBase, TempArray);
	Finalise(DataBase);
}
