// astore.h
// 15/5/99
// Stores vertex records and references them by key address pair records
// Ken Brownsey

#ifndef	ASTORE_H
#define 	ASTORE_H

#include "ArcData.h"

typedef struct {
	ArcKey_T	ArcKey;
	VertKey_T	InitialVertKey,
					FinalVertKey;
	int	Weight;
	ArcDataRec_T *Address;
} ArcKAPRec_T;

// PRE	TRUE
// POST	RETURNS a key adddress pair record with key that of record and
//			address that of location where record is stored
ArcKAPRec_T
MakeArcKAPRec(ArcDataRec_T Rec);


// PRE	TRUE
// POST	RETURNS key value of ArcKAPRec
ArcKey_T
Get_ArcKAPRecKey(ArcKAPRec_T ArcKAPRec);


// PRE	TRUE
// POST	RETURNS from vertex key value of ArcKAPRec
VertKey_T
Get_ArcKAPRecInitialKey(ArcKAPRec_T ArcKAPRec);


// PRE	TRUE
// POST	RETURNS to vertex key value of ArcKAPRec
VertKey_T
Get_ArcKAPRecFinalKey(ArcKAPRec_T ArcKAPRec);


// PRE	TRUE
// POST	RETURNS weight of ArcKAPRec
VertKey_T
Get_ArcKAPRecWeight(ArcKAPRec_T ArcKAPRec);


// PRE	TRUE
// POST	RETURNS record stored at address value of ArcKAPRec
ArcDataRec_T
Get_ArcDataRec(ArcKAPRec_T ArcKAPRec);


// PRE	TRUE
// POST	Memory taken up by record referenced
//			by address attribute is freed up
void
Free_ArcKAPRecMemory(ArcKAPRec_T ArcKAPRec);

#endif


