// VVertStack.h
// 14/5/99
// VVertStack_T is a stack of vertices
// Ken Brownsey

#include "my_const.h"

typedef void *SElement_T;
typedef void *VertStack_T;

// PRE	TRUE
// POST	RETURNS an initialised VertStack_T
VertStack_T
Create_VertStack();


// PRE	NOT Q_FullVertStack(VertStack)
// POST 	elements of VertStack' = elements of VertStack union {Element}
void
Push(SElement_T NewElement, VertStack_T VertStack);


// PRE	TRUE
// POST	IF VertStack is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyVertStack(VertStack_T VertStack);


// PRE	TRUE
// POST	IF VertStack is full
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_FullVertStack(VertStack_T VertStack);


// PRE	NOT Q_EmptyVertStack(VertStack)
// POST	VertStack' is VertStack with the most recently entered
//			element removed
void
Pop(VertStack_T VertStack);


// PRE	NOT Q_EmptyVertStack(VertStack)
// POST	RETURNS the value of the most recently
//				entered element of VertStack *)
SElement_T
Top(VertStack_T VertStack);



//	PRE	Q_EmptyVertStack(VertStack)
//	POST	all memory allocated to VertStack is freed up
// NOTES	VertStack will need to be re-initialised
//			with Create_VertStack() before being used again
void
Free_VertStack(VertStack_T VertStack);
