// VStore.cpp
// 14/5/99
// Stores vertex records and references them by key address pair records
// Ken Brownsey

#include "vstore.h"
#include <stdlib.h>


// PRE	TRUE
// POST	RETURNS a key adddress pair record with key that of record and
//			address that of location where record is stored
VertKAPRec_T
MakeVertKAPRec(VertDataRec_T Rec) {
	VertKAPRec_T VertKAPRec;
	VertDataRec_T *Address;

	Address = new VertDataRec_T;
	(*Address) = Rec;
	VertKAPRec.VertKey = Get_VertKey(Rec);
	VertKAPRec.Address = Address;
	return(VertKAPRec);
}


// PRE	TRUE
// POST	RETURNS key value of VertKAPRec
VertKey_T
Get_VertKAPRecKey(VertKAPRec_T VertKAPRec) {

	return(VertKAPRec.VertKey);
}


// PRE	TRUE
// POST	RETURNS record stored at address value of VertKAPRec
VertDataRec_T
Get_VertDataRec(VertKAPRec_T VertKAPRec) {

	return(*(VertKAPRec.Address));
}


//	PRE	TRUE
//	POST	IF VertKAPRec has been marked
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Marked(VertKAPRec_T VertKAPRec) {

	return(VertKAPRec.Q_Marked);
}


//	PRE	TRUE
//	POST	VertKAPRec' is marked
void
Mark_Vert(VertKAPRec_T &VertKAPRec) {

	VertKAPRec.Q_Marked = TRUE;
}


//	PRE	TRUE
//	POST	VertKAPRec' is not marked
void
UnMark_Vert(VertKAPRec_T &VertKAPRec) {

	VertKAPRec.Q_Marked = FALSE;
}


// PRE	TRUE
// POST	Get_PathPred(VertKAPRec')  = PredVertKey
void
Set_PathPred(VertKAPRec_T &VertKAPRec,  VertKey_T PredVertKey) {

	VertKAPRec.PredVertKey = PredVertKey;
}


// PRE	TRUE
// POST	RETURNS key value of predecessor of Get_VertKAPRecKey(VertKAPRec)
VertKey_T
Get_PathPred(VertKAPRec_T VertKAPRec) {

	return(VertKAPRec.PredVertKey);
}



// PRE	TRUE
// POST	Get_PathWeightUB(VertKAPRec')  = PathWeight
void
Set_PathWeightUB(VertKAPRec_T &VertKAPRec,  int PathWeight) {

	VertKAPRec.PathWeight = PathWeight;
}


// PRE	TRUE
// POST	RETURNS upper bound on shortest path to Get_VertKAPRecKey(VertKAPRec)
int
Get_PathWeightUB(VertKAPRec_T VertKAPRec) {

	return(VertKAPRec.PathWeight);
}




// PRE	TRUE
// POST	Memory taken up by record referenced
//			by address attribute is freed up
void
Free_VertKAPRecMemory(VertKAPRec_T VertKAPRec) {

	delete(VertKAPRec.Address);
}



