// vstore.h
// 15/5/99
// Stores vertex records and references them by key address pair records
// Ken Brownsey

#ifndef	VSTORE_H
#define 	VSTORE_H

#define	NullVertKey	-1
#include "VertData.h"

typedef struct {
	VertKey_T	VertKey;
	VertDataRec_T *Address;
	BOOLEAN		Q_Marked;
	int			PathWeight;
	VertKey_T 	PredVertKey;
} VertKAPRec_T;

// PRE	TRUE
// POST	RETURNS a key adddress pair record with key that of record and
//			address that of location where record is stored
VertKAPRec_T
MakeVertKAPRec(VertDataRec_T Rec);


// PRE	TRUE
// POST	RETURNS key value of VertKAPRec
VertKey_T
Get_VertKAPRecKey(VertKAPRec_T VertKAPRec);



// PRE	TRUE
// POST	RETURNS record stored at address value of VertKAPRec
VertDataRec_T
Get_VertDataRec(VertKAPRec_T VertKAPRec);


// PRE	TRUE
// POST	record stored at address value of VertKAPRec is overwritten with Rec
void
Update_Rec(VertKAPRec_T VertKAPRec, VertDataRec_T Rec);


//	PRE	TRUE
//	POST	IF VertKAPRec has been marked
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Marked(VertKAPRec_T VertKAPRec);


//	PRE	TRUE
//	POST	VertKAPRec' is marked
void
Mark_Vert(VertKAPRec_T &VertKAPRec);


//	PRE	TRUE
//	POST	VertKAPRec' is not marked
void
UnMark_Vert(VertKAPRec_T &VertKAPRec);


// PRE	TRUE
// POST	Get_PathPred(VertKAPRec')  = PredVertKey
void
Set_PathPred(VertKAPRec_T &VertKAPRec,  VertKey_T PredVertKey);


// PRE	TRUE
// POST	RETURNS key value of predecessor of Get_VertKAPRecKey(VertKAPRec)
VertKey_T
Get_PathPred(VertKAPRec_T VertKAPRec);


// PRE	TRUE
// POST	Get_PathWeightUB(VertKAPRec')  = PathWeight
void
Set_PathWeightUB(VertKAPRec_T &VertKAPRec,  int PathWeight);


// PRE	TRUE
// POST	RETURNS upper bound on shortest path to Get_VertKAPRecKey(VertKAPRec)
int
Get_PathWeightUB(VertKAPRec_T VertKAPRec);


// PRE	TRUE
// POST	Memory taken up by record referenced
//			by address attribute is freed up
void
Free_VertKAPRecMemory(VertKAPRec_T VertKAPRec);

#endif


