// arc.h
// 14/5/99
// Ken Brownsey
//	arc records for Graph_T
#ifndef	ARC_H
#define 	ARC_H

#include <fstream.h>
#include "my_const.h"
#include "vstore.h"

typedef int	ArcKey_T;

typedef struct {
	ArcKey_T	Number;
	char	*Name;
	VertKAPRec_T	FromVertKAPRec,
						ToVertKAPRec;
} ArcRec_T;

// PRE	TRUE
// POST	user is prompted for arc key value which is returned
ArcKey_T
Read_ArcKey();


// PRE	TRUE
// POST	key value is written to screen
void
Write_ArcKey(ArcKey_T ArcKey);


// PRE	TRUE
// POST	returnS key value of ArcRec
ArcKey_T
Get_ArcKey(ArcRec_T ArcRec);


// PRE	TRUE
// POST	returnS key value of source vertex in ArcRec
VertKey_T
Get_FromVertKey(ArcRec_T ArcRec);


// PRE	TRUE
// POST	returnS key value of sink vertex in ArcRec
VertKey_T
Get_ToVertKey(ArcRec_T ArcRec);


//	PRE	TRUE
//	POST	prompts user for arc details
//			which are read into ArcRec
void
Read_ArcRecDetails(ArcRec_T &ArcRec);


//	PRE	TRUE
//	POST	writes ArcRec to screen
void
Write_ArcRec(ArcRec_T ArcRec);


// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
ArcRec_T
Read_ArcRec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile);



// PRE	FileHandle is a correctly opened stream
// POST	ArcRec written to FileHandle stream
void
Write_ArcRec_To_File (ArcRec_T ArcRec, ofstream &OutFile);

#endif
