#include"board.h"
#include <stdlib.h>
#include <iostream.h>

/* NumGeese = NumCols/2 */
#define NumGeese 4

Board_T	Board;

Position_T	FoxPosition;
Position_T	GeesePositions[4];



/* PRE	TRUE */
/* POST Board displayed to screen */
void
Display_Board(Board_T Board) {
	int	Row,
		Col;
	Position_T	Position;
	enum SquareStatus_T Status;

	for (Row = 1; Row <= NumRows; Row++) {
		cout 	<< "\n"
				<< Row;
		for (Col = 1; Col <= NumCols; Col++) {
			Position = Make_Position(Row, Col);
			Status = Get_Status(Position, Board);
			switch(Status) {
				case Empty :
					if (Q_BlackSquare(Position)) {
						cout << "  ";
					}
					else {
						cout << " #";
					}
				break;

				case WhitePiece :
					cout << " G";
				break;

				case BlackPiece :
					cout << " F";
				break;
			}
		}
	}
	cout << "\n\n  ";
	for (Col = 1; Col <= NumCols; Col++) {
		cout 	<< Col
				<< " ";
	}
}


/* PRE	TRUE */
/* POST Board initialiased to Empty squares except where Fox and Geese go*/
void
Initialise_Board(Board_T Board) {
	int	Row,
			Col;
	int	Index;
	Position_T	Position;

	for (Row = 1; Row <= NumRows; Row++) {
		for (Col = 1; Col <= NumCols; Col++) {
			Position = Make_Position(Row, Col);
			Set_Status(Position, Empty, Board);
		}
	}
	Position = Make_Position(1, 1);
	Set_Status(Position, BlackPiece, Board);
	FoxPosition = Position;
	for (Col = 2, Index = 0; Col <= NumCols; Col = Col + 2, Index++) {
		Position = Make_Position(NumRows, Col);
		Set_Status(Position, WhitePiece, Board);
		GeesePositions[Index] = Position;
	}
}


/* PRE	On_Board(Position) AND OnBoard(NextPosition) */
/* POST	Get_Status(NextPosition)' = Get_Status(Position)
		AND Get_Status(Position)' = Empty */
void
Move_Piece(Position_T Position, Position_T NextPosition, Board_T Board) {
	Set_Status(NextPosition, Get_Status(Position, Board), Board);
	Set_Status(Position, Empty, Board);
}


/* PRE	Q_OnBoard(Position) */
/* POST	IF there is a valid move from
				Position in Direction on Board THEN RETURNS TRUE
			ELSE
				RETURNS FALSE */
BOOLEAN
Q_CanGo(Position_T Position, Direction_T Direction, Board_T Board) {
	Position_T NextPosition;

	NextPosition = Get_NextPosition(Position, Direction);
	if (Q_OnBoard(NextPosition)) {
		if (Get_Status(NextPosition, Board) == Empty) {
			return(TRUE);
		}
		else {
			return(FALSE);
		}
	}
	else {
		return(FALSE);
	}
}




/* PRE	TRUE */
/* POST	IF no goose can move THEN RETURNS TRUE
			ELSE RETURNS FALSE */
BOOLEAN
Q_StaleMate(Board_T Board) {
	BOOLEAN	Q_CanMove;
	int	Index;

	Q_CanMove = FALSE;
	for (Index = 0; (Index < NumGeese) && (!Q_CanMove) ; Index ++) {
		if (	(Q_CanGo(GeesePositions[Index], NE, Board)) ||
				(Q_CanGo(GeesePositions[Index], NW, Board))) {
					Q_CanMove = TRUE;
		}
	}
	return(!Q_CanMove);
}




/* PRE	TRUE */
/* POST	user prompted for board position
		AND IF position contains a goose,
				user is prompted for a direction
				AND IF goose can move in that direction
						goose is moved in that direction
					ELSE
						appropriate error message
				ELSE
					appropriate error message */
void
Goose_Move(Board_T Board) {
	int	Row,
			Col;
	int	Index;
	Position_T	Position,
			NextPosition;
	BOOLEAN 	Q_MoveMade,
				Q_OK;
	enum	Direction_T Direction;

	cout	<< "\n\n\nOne of the geese to move";
	for(Q_MoveMade = FALSE; !Q_MoveMade;) {
		Q_OK = TRUE;
		cout	<< "\nType in row number of goose ==> ";
		cin 	>> Row;
		cout 	<<"\nType in column number of goose ==> ";
		cin 	>> Col;
		Position = Make_Position(Row, Col);
		if (!Q_OnBoard(Position)) {
			cout	<<	"\nSquare ";
			Write_Position(Position);
			cout	<< " not on board";
			Q_OK = FALSE;
		}

		if (Q_OK) {
			if (Get_Status(Position, Board) != WhitePiece) {
				cout	<<	"\nSquare ";
				Write_Position(Position);
				cout	<< " does not contain a goose";
				Q_OK = FALSE;
			}
		}

		if (Q_OK) {
			if (Row == 1) {
				cout <<"\nThis goose is cooked - cannot move further";
				Q_OK = FALSE;
			}
		}

		if (Q_OK) {
			cout	<< "\nChoose either North West or North East to move to\n";
			Direction = Read_Direction();
			if (!Q_ValidDirection(Direction)) {
				cout	<< "\n\nInvalid direction";
				Q_OK = FALSE;
			}
			else {
				if ((Direction != NW)&&(Direction != NE)) {
					cout	<< "Geese cannot move ";
					Write_Direction(Direction);
					Q_OK = FALSE;
				}
			}
		}

		if (Q_OK) {
			NextPosition = Get_NextPosition(Position, Direction);
			if (!Q_OnBoard(NextPosition)) {
				cout	<< "\nGoing ";
				Write_Direction(Direction);
				cout	<< " will move piece off board";
				Q_OK = FALSE;
			}
			else {
				if (!Get_Status(NextPosition, Board) == Empty) {
					cout << "\nBoard occupied to the ";
					Write_Direction(Direction);
					Q_OK = FALSE;
				}
			}
		}

		if (Q_OK) {
			for (Index = 0; (!Q_SamePosition(GeesePositions[Index], Position)) && (Index < 4) ; Index ++) {
			}
			Move_Piece(Position, NextPosition, Board);
			GeesePositions[Index] = NextPosition;
			Q_MoveMade = TRUE;
		}
		else {
			cout << "\n\n\nTry again";
			Display_Board(Board);
		}
	}
}

/* PRE	TRUE */
/* POST RETURNS position of fox on Board */
Position_T
Find_Fox(Board_T Board) {
	int	Row,
		Col;
	Position_T Position;
	BOOLEAN	Q_Found;

	for (Row = 1, Q_Found = FALSE;
		(Row <= NumRows) && (!Q_Found); Row++) {
		for (Col = 1, Q_Found = FALSE;
			(Col <= NumCols) && (!Q_Found); Col++) {
			Position = Make_Position(Row, Col);
			if (Get_Status(Position, Board) == BlackPiece) {
				Q_Found = TRUE;
			}
		}
	}
	return(Position);
}


/*	PRE	TRUE */
/* POST	IF Fox has won THEN RETURNS TRUE
			ELSE RETURNS FALSE */
BOOLEAN
Q_FoxWins(Board_T Board) {
	Position_T 	FoxPosition,
					NextSouth;

	FoxPosition = Find_Fox(Board);
	NextSouth = Get_NextPosition(FoxPosition, S);
	return(!Q_OnBoard(NextSouth));
}


/* PRE  fox can move in at least one direction */
/* POST fox moves in one direction at random */
void
Fox_Move(Board_T Board) {
	Position_T	Position,
			NextPosition;
	enum	Direction_T Direction;


	cout	<< "\n\n\nFox to move";
	Position = Find_Fox(Board);
	Direction = Random_Direction();
	NextPosition = Get_NextPosition(Position, Direction);
	for (;(!Q_OnBoard(NextPosition)) || (Get_Status(NextPosition, Board) != Empty);) {
		Direction = Random_Direction();
		NextPosition = Get_NextPosition(Position, Direction);
	}
	Move_Piece(Position, NextPosition, Board);
}


/* PRE	TRUE */
/* POST	IF Fox cannot move THEN RETURNS TRUE */
/*			ELSE RETURNS FALSE */
BOOLEAN
Q_GeeseWin(Board_T Board) {
	Position_T 	FoxPosition;

	FoxPosition = Find_Fox(Board);

	if (	(Q_CanGo(FoxPosition, NE, Board)) ||
			(Q_CanGo(FoxPosition, SE, Board)) ||
			(Q_CanGo(FoxPosition, SW, Board)) ||
			(Q_CanGo(FoxPosition, NW, Board))) {
			return(FALSE);
	}
	else {
		return(TRUE);
	}
}


/* PRE	TRUE */
/* POST	Program interacts, as fox, with user
			in game of fox and geese until a win or stalemate */
void
Play_FoxAndGeese(Board_T Board) {
	BOOLEAN	Q_GameOver;

	Q_GameOver = FALSE;

	for (;!Q_GameOver;) {
		Fox_Move(Board);
		Display_Board(Board);
		if (Q_FoxWins(Board)) {
			cout	<< "Well done the fox";
			Q_GameOver = TRUE;
		}
		if (!Q_GameOver) {
			if (Q_StaleMate(Board)) {
				cout	<< "Stalemate - game over";
				cout	<< "\nGeese all stuck and fox not home";
				Q_GameOver = TRUE;
			}
			else {
				Goose_Move(Board);
				Display_Board(Board);
				if (Q_GeeseWin(Board)) {
					cout	<< "\nSauce for the geese";
					Q_GameOver = TRUE;
				}
			}
		}
	}
}




/* PRE	TRUE */
/* POST	Sets up */
void
Initialise() {
	cout	<< "Here we go !\n";
	Initialise_Board(Board);
}


void
Loop() {

	char 	Request;
	int	RequestCount;

	for (Request = ' ', RequestCount = 0; Request != 'x'; RequestCount++) {

		Display_Board(Board);
		Play_FoxAndGeese(Board);

		Initialise_Board(Board);

		cout	<< "\nx to halt ==> ";
		cin	>> Request;
	}
}


/* PRE	TRUE */
/* POST	Clears up */
void
Finalise() {
	cout 	<< "That is it !\n";
}


void
main() {
	Board = Create_Board();
	Initialise();
	Loop();
	Finalise();
}


