// ord_db.cpp
// 1/8/98
// Demo of keeping ordered sequence
// Ken Brownsey


#include <iostream.h>
#include "my_const.h"

#include <iostream.h>
#include "sequence.h"

typedef Sequence_T StudentDB_T;

//	PRE	Q_Full(DB) is FALSE
//       AND keys in DB are in order
// POST	DB' = DB with NewRec added
//       AND keys in DB' are in order
void
Add_Stud(StudentRec_T NewStud, StudentDB_T DB) {
	cout	<< "\nWe want records ordered by key value"
			<< "\nHow long it takes is really up to you"
			<< "\nThe values of keys must be compared"
			<< "\nUsing procedures already shared"
			<< "\nAs well as those to move around the list too\n";
}




//	PRE	TRUE
// POST	IF there exists an element of DBase such that
//			Get_KAPRecKey(El) = Key
//				El = Get_Current(DB)
//				AND RETURNS TRUE
//			ELSE
//				IF NOT Q_Empty(DB)
//					Q_At_End(DB)
//					AND RETURNS FALSE
BOOLEAN
Q_Present(Key_T Key, StudentDB_T DB) {
	BOOLEAN	Q_Found;

	if (Q_Empty(DB)) {
		return(FALSE);
	}
	else {
		Go_To_Head(DB);
		Q_Found = FALSE;
		for(;!Q_At_End(DB) && !Q_Found;) {
			if (Get_KAPRecKey(Get_Current(DB)) == Key) {
				Q_Found = TRUE;
				// NOT Q_At_End(DB)
			}
			else {
				Go_To_Next(DB);
			}
		}
		//	EITHER	Q_Found AND Get_KAPRecKey(Get_Current(DB)) = Key
		//	OR       Q_At_End(DB) AND Get_KAPRecKey(Get_Current(DB)) = Key
		//	OR			Q_At_End(DB) AND Get_KAPRecKey(Get_Current(DB)) <> Key
		return(Get_KAPRecKey(Get_Current(DB)) == Key);
	}
}


// PRE	Q_Present(Key, DB)
// POST	RETURNS record with key value Key
StudentRec_T
Retrieve(Key_T Key, StudentDB_T DB) {

	Go_To_Head(DB);
	for (; (!Q_At_End(DB)) && (Key > Get_KAPRecKey(Get_Current(DB)));) {
		Go_To_Next(DB);
	}
	// EITHER 	Q_At_End AND Key > Get_KAPRecKey(Get_Current(DB))
	// OR			Q_At_End AND Key <= Get_KAPRecKey(Get_Current(DB))
	// OR			NOT Q_At_End AND Q_At_End AND Key <= Get_KAPRecKey(Get_Current(DB))
	return(Get_DataRec(Get_Current(DB)));
}


// PRE TRUE
// POST	IF Q_Full(DB) appropriate message is printed
//			ELSE user is prompted for number to be added to DB
void
Read_NewStud_InOrder(StudentDB_T DB) {
	StudentRec_T	NewStud;

	if (Q_Full(DB)) {
		cout 	<< "Sorry - table is now full\n";
	}
	else {
		cout	<< "Please type in a new record to be added ==> ";
		Read_Rec(NewStud);
		Add_Stud(NewStud, DB);
	}
}


// PRE TRUE
// POST 	prompts user for key value
//			IF key value is in DB prints out message to say so
//       ELSE prints out message to show it is not there
void
Check_Stud(StudentDB_T DB) {
	Key_T	Key;

	if (!Q_Empty(DB)){
		cout 	<< "Please type in key of student record to check ==> ";
		Key = Read_Key();

		if (Q_Present(Key, DB)) {
			cout	<< "Student record with key ";
			Write_Key(Key);
			cout	<< " is in the table\n";
		}
		else {
			cout	<< "There is no student record with key ";
			Write_Key(Key);
			cout	<< " in the table\n";
		}
	}
	else {
		cout	<< ("\nDB is empty - nothing to check\n");
	}
}


// PRE TRUE
// POST 	prompts user for key value
//			IF key value is in DB prints out record for key
//       ELSE prints out message to show it is not there
void
Print_StudRec(StudentDB_T DB) {
	Key_T	Key;

	if (!Q_Empty(DB)){
		cout 	<< "Please type in key of student record to print out ==> ";
		Key = Read_Key();

		if (Q_Present(Key, DB)) {
			cout	<< "Student record with key ";
			Write_Key(Key);
			cout	<< " has record as follows \n";
			Write_Rec(Retrieve(Key, DB));
		}
		else {
			cout	<< "There is no student record with key ";
			Write_Key(Key);
			cout	<< " in the table\n";
		}
	}
	else {
		cout	<< ("\nDB is empty - nothing to check\n");
	}
}


//	PRE	TRUE
//	POST	IF DB is not empty all values are printed to screen
//			ELSE message to say that DB is empty
void
Print_All(StudentDB_T DB) {

	if (!Q_Empty(DB)) {
		cout	<< "\n******************\nContents of the table are as follows\n\n";
		Go_To_Head(DB);
		for(;!Q_At_End(DB);) {
			Write_Rec(Get_DataRec(Get_Current(DB)));
			Go_To_Next(DB);
			cout	<< "\n";
		}
		Write_Rec(Get_DataRec(Get_Current(DB)));
		cout	<< ("\n******************\nThat's all!\n");
	}
	else {
		cout	<< ("\nDatabase is empty - nothing to print\n\n");
	}
}


//	PRE	TRUE
//	POST	IF DB is not empty all values are printed to screen
//			ELSE message to say that DB is empty
void
Print_All_Keys(StudentDB_T DB) {

	if (!Q_Empty(DB)) {
		cout	<< "\n******************\nKeys of the table are as follows\n\n";
		Go_To_Head(DB);
		for(;!Q_At_End(DB);) {
			Write_Key(Get_KAPRecKey(Get_Current(DB)));
			Go_To_Next(DB);
			cout	<< "\n";
		}
			Write_Key(Get_KAPRecKey(Get_Current(DB)));
		cout	<< ("\n******************\nThat's all the keys!\n");
	}
	else {
		cout	<< ("\nDatabase is empty - no keys to print\n\n");
	}
}



// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	put new record into key (o)rder *********\n"
			<< "***	(p)rint all records        **************\n"
			<< "***	print all (k)eys           **************\n"
			<< "***	(c)heck student key        **************\n"
			<< "***	print (s)tudent record     **************\n"
			<< "***   e(x)it					      **************\n"
			<< "***   (m)enu						   **************\n";
}


// PRE	TRUE
// POST	Clears up
void
Initialise(StudentDB_T *DB_Ptr) {

	(*DB_Ptr) = Create_Sequence();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(StudentDB_T DB) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'o' :	Read_NewStud_InOrder(DB);
				break;
			case 'p' :	Print_All(DB);
				break;
			case 'k' :	Print_All_Keys(DB);
				break;
			case 'c' :	Check_Stud(DB);
				break;
			case 's' :	Print_StudRec(DB);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(StudentDB_T DB) {
	for(;!Q_Empty(DB);) {
		Delete_Current(DB);
	}
	Free_Sequence(DB);
	cout	<< "That is it !\n";
}


void
main() {
	StudentDB_T	DataBase;

	Initialise(&DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}

