// two_way.def
// 1/8/98
// TwoWay_T implementation based on doubly linked list
// Ken Brownsey
#include "my_const.h"
#include "store.h"

typedef KAPRec_T		Element_T;
typedef void	*TwoWay_T;

// PRE	TRUE
// POST	RETURNS an initialised TwoWay_T
TwoWay_T
Create_TwoWay();


// PRE	TRUE
//	POST	IF TWSeq is full THEN
//				RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_Full(TwoWay_T TWSeq);


// PRE	TRUE
//	POST	IF TWSeq is empty THEN RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_Empty(TwoWay_T TWSeq);


// PRE	NOT Q_Empty(TWSeq)
//	POST	IF current element first in TWSeq THEN
//				RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_At_Start(TwoWay_T TWSeq);


// PRE	NOT Q_Empty(TWSeq)
//	POST	IF current element last in TWSeq THEN
//				RETURNS TRUE
//			ELSE RETURNS FALSE
BOOLEAN
Q_At_End(TwoWay_T TWSeq);


// PRE	NOT Q_Empty(TWSeq)
//	POST	first element of TWSeq' is the current element
void
Go_To_Head(TwoWay_T TWSeq);


// PRE	NOT Q_Empty(TWSeq) AND
//			NOT Q_At_End(TWSeq)
//	POST	current element in TWSeq' is the one after
//			current element in TWSeq
void
Go_To_Next(TwoWay_T TWSeq);


// PRE	NOT Q_Empty(TWSeq) AND
//			NOT Q_At_Start(TWSeq)
//	POST	current element in TWSeq' is the one before
//			current element in TWSeq
void
Go_To_Prev(TwoWay_T TWSeq);


// PRE	NOT Q_Empty(TWSeq)
// POST	RETURNS current record
Element_T
Get_Current(TwoWay_T TWSeq);


// PRE	TRUE
// POST	TWSeq'= TWSeq with NewRec added AND
//			IF Q_Empty(TWSeq) THEN
//				current of TWSeq' is first element
//			ELSE
//				NewRec is after current in TWSeq'
void
Append_After_Current(Element_T NewRec, TwoWay_T TWSeq);


// PRE	NOT Q_Empty(TWSeq)
// POST	TWSeq':= TWSeq with NewRec added AND
//			NewRec is before current in TWSeq'
void
Insert_Before_Current(Element_T NewRec, TwoWay_T TWSeq);


// PRE	NOT Q_Empty(TWSeq)
// POST	TWSeq':= TWSeq with current of TWSeq removed AND
//			IF NOT(Q_Empty(TWSeq'))
//				current of TWSeq' is first element of TWSeq'
void
Delete_Current(TwoWay_T TWSeq);


//	PRE	Q_Empty(TWSeq)
//	POST	all memory allocated to TWSeq is freed up
// NOTES	TWSeq will need to be re-initialised
//			with Create_TWSeq() before being used again
void
Free_TWSeq(TwoWay_T TWSeq);

