// tw_st_db.mod
// 1/8/98
// Demonstrates use of Two_Way_T
// Ken Brownsey


#include "two_way.h"
#include "iostream.h"


typedef TwoWay_T StudentDB_T;

StudentDB_T DataBase;

// PRE	TRUE
// POST	if (Q_Empty(DB)
//				Message to say so
//			else {
//				Message to say not empty
void
Test_Empty(StudentDB_T DB) {

	if (Q_Empty(DB)) {
		cout	<<	"Database is empty";
	}
	else {
		cout	<<	"Database is not empty";
	}
}


// PRE	TRUE
// POST	if (Q_Full(DB)
//				Message to say so
//			else {
//				Message to say not empty
void
Test_Full(StudentDB_T DB) {

	if (Q_Full(DB)) {
		cout	<<	"Database is full";
	}
	else {
		cout	<<	"Database is not full";
	}
}


// PRE	TRUE
// POST	if (! Q_Empty(DB)
//				if (Q_At_End(DB)
//					Message to say so
//				else {
//					Message to say not at end
//			else {
//				Message to say empty
void
Test_End(StudentDB_T DB) {

	if (! Q_Empty(DB)) {
		if (Q_At_End(DB)) {
			cout	<<	"At end of database";
		}
		else {
			cout	<<	"Not at end of database";
		}
	}
	else {
		cout	<<	"Database is empty";
	}
}



// PRE	TRUE
// POST	if (! Q_Empty(DB)
//				if (Q_At_Start(DB)
//					Message to say so
//				else {
//					Message to say not at end
//			else {
//				Message to say empty
void
Test_Start(StudentDB_T DB) {

	if (! Q_Empty(DB)) {
		if (Q_At_Start(DB)) {
			cout	<<	"At start of database";
		}
		else {
			cout	<<	"Not at start of database";
		}
	}
	else {
		cout	<<	"Database is empty";
	}
};



// PRE	TRUE
// POST  if (! Q_Full(DataBase) {
//				user is prompted for Rec
//				DataBase' == Append_After_Current(Frac, DataBase)
//			else { appropriate message
void
Put_AfterCurrent(StudentDB_T DataBase) {
	StudentRec_T	NewRec;
	KAPRec_T 		KAPRec;

	if (Q_Full(DataBase)) {
		cout	<<	"Database is full";
	}
	else {
		cout	<<	"Please type in new record";
		Read_Rec(NewRec);
		KAPRec = Make_KAPRec(NewRec);
		Append_After_Current(KAPRec, DataBase);
	}
}


// PRE	TRUE
// POST  if (! Q_Full(DataBase) AND ! Q_Empty(DataBase) {
//				user is prompted for Rec
//				DataBase' == Insert_Before_Current(Rec, DataBase)
//			else { appropriate message
void
Put_BeforeCurrent(StudentDB_T DataBase) {
	StudentRec_T	NewRec;
	KAPRec_T 		KAPRec;

	if (Q_Full(DataBase)){
		cout	<<	"Database is full";
	}
	else {
		if (Q_Empty(DataBase)) {
			cout	<<	"Database is empty";
		}
		else {
			cout	<<	"Please type in new record";
			Read_Rec(NewRec);
			KAPRec = Make_KAPRec(NewRec);
			Insert_Before_Current(KAPRec, DataBase);
		}
	}
}


// PRE	TRUE
// POST  if (! Q_Empty(DataBase) {
//				DataBase' == Delete_Current(DataBase)
//			else { appropriate message
void
Remove_Current(StudentDB_T  DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<<	"Database is empty";
	}
	else {
		Free_RecMemory(Get_Current(DataBase));
		Delete_Current(DataBase);
	}
}


// PRE	TRUE
// POST  if (! Q_Empty(DataBase) {
//				current element is printed to screen
//			else { appropriate message
void
Print_Current(StudentDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<<	"Database is empty";
	}
	else {
		Write_Rec(Get_DataRec(Get_Current(DataBase)));
	}
}


// PRE	TRUE
// POST  if (! Q_Empty(DataBase) AND ! Q_At_End(DataBase)
//				DataBase' == Go_To_Next(DataBase)
//			else { appropriate message
void
Move_Forward(StudentDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<<	"Database is empty";
	}
	else {
		if (Q_At_End(DataBase)) {
			cout	<<	"At end of database";
		}
		else {
			Go_To_Next(DataBase);
		}
	}
}


// PRE	TRUE
// POST  if (! Q_Empty(DataBase) AND ! Q_At_Start(DataBase)
//				DataBase' == Go_To_Prev(DataBase)
//			else { appropriate message
void
Move_Backward(StudentDB_T DataBase) {

	if (Q_Empty(DataBase)) {
		cout	<<	"Database is empty";
	}
	else {
		if (Q_At_Start(DataBase)) {
			cout	<<	"At start of database";
		}
		else {
			Go_To_Prev(DataBase);
		}
	}
}


// PRE	TRUE
// POST  if (! Q_Empty(DataBase)
//				DataBase' == Go_To_Head(DataBase)
//			else { appropriate message
void
Move_ToHead(StudentDB_T DataBase) {

	if (Q_Empty(DataBase)){
		cout	<<	"Database is empty";
	}
	else {
		Go_To_Head(DataBase);
	}
}

// PRE	! Q_Empty_TWSeq(DataBase)
// POST  RETURNS number of elements in DataBase
//			AND DataBase' == Go_To_Head(DataBase)
// !ES	this is a function with side effects
int
Find_Size(StudentDB_T DB) {
	int Size;

	Go_To_Head(DB);
	Size = 1;
	for(;!Q_At_End(DB); Size++) {
		Go_To_Next(DB);
	}
	Go_To_Head(DB);
	return(Size);
}


// PRE	TRUE
// if (Q_Empty(DB) {
//		appropriate message
//	else { prints out number of elements in DB
//			AND DB' == Go_To_Head(DB)
void
Print_Size(StudentDB_T DB) {


	if (Q_Empty(DB)) {
		cout	<<	"Empty database - 0 records";
	}
	else {
		cout	<<	"Number of elements is "
				<<	Find_Size(DB)
				<< "\n\n";
	}
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {

	cout	<<	"\n***	test to see if data base is (e)mpty ********";
	cout	<<	"\n***	test to see if data base is f(u)ll *********";
	cout	<<	"\n***	test to see if at e(n)d of data base *******";
	cout	<<	"\n***	test to see if at (b)eginning of data base *";
	cout	<<	"\n***	(a)ppend a new record after current ********";
	cout	<<	"\n***	(i)nsert a new record before current *******";
	cout	<<	"\n***	(r)emove current ***************************";
	cout	<<	"\n***	move current element (f)orward *************";
	cout	<<	"\n***	move current element bac(k)ward ************";
	cout	<<	"\n***	make current element (h)ead ****************";
	cout	<<	"\n***	(p)rint current record     *****************";
	cout	<<	"\n***	print (s)ize of database   *****************";
	cout	<<	"\n***   e(x)it					   ********************";
	cout	<<	"\n***   (m)enu					   ********************";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise(StudentDB_T &StDB) {

	StDB = Create_TwoWay();
	cout	<<	"Here we go !";
}


// PRE	TRUE 
// POST Goes into a prompt, read and execute cycle 
//		until 'x' is the character read
void
Loop(StudentDB_T DB) {
	char	Request;
	int	RequestCount;

	Request = 'm';
	RequestCount = 0;

	for(;Request != 'x';) {

		switch(Request) {

			case 'e' :	Test_Empty(DB); break;
			case 'u' :	Test_Full(DB); break;
			case 'n' :	Test_End(DB); break;
			case 'b' :	Test_Start(DB); break;
			case 'a' :	Put_AfterCurrent(DB); break;
			case 'i' :	Put_BeforeCurrent(DB); break;
			case 'r' :	Remove_Current(DB); break;
			case 'p' :	Print_Current(DB); break;
			case 'f' :	Move_Forward(DB); break;
			case 'k' :	Move_Backward(DB); break;
			case 'h' :	Move_ToHead(DB); break;
			case 's' :	Print_Size(DB); break;
			case 'm' : 	Menu(); cout	<<	"\n\n\n"; break;
			default	:	cout	<<	" m for menu ";
		}
		RequestCount++;
		cout	<<	"\n\nNext request ["
				<<	RequestCount
				<<	"] ===> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(StudentDB_T DB) {

	for (;!Q_Empty(DB);) {
		Delete_Current(DB);
	}
	Free_TWSeq(DB);
	cout	<<	"That is it !";
}

void
main() {
	Initialise(DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}