// eval.cpp
// 7/8/98
// Demonstrates application of Stack_T in evaluation
// Ken Brownsey

#include <iostream.h>
#include "stack.h"
	#include <stdio.h>
	#include <conio.h>
typedef Stack_T Stack_T;


// PRE	TRUE
// POST  all elements of Stack printed to screen
void
Print_Stack(Stack_T Stack) {
	Stack_T TempStack;
	ArithToken_T	ArithToken;


	if (Q_EmptyStack(Stack)) {
		cout	<< "Stack is empty";
	}
	else {
		TempStack = Create_Stack();
		for(;! Q_EmptyStack(Stack);) {
			ArithToken = Top(Stack);
			Pop(Stack);
			Write_Rec(ArithToken);
			cout 	<< " ";
			Push(ArithToken, TempStack);
		}
		for(;! Q_EmptyStack(TempStack);) {
			ArithToken = Top(TempStack);
			Pop(TempStack);
			Push(ArithToken, Stack);
		}
		Free_Stack(TempStack);
	}
}


// PRE	TRUE
// POST	Reads in tokens from keyboard into Stack
//			until new line token encountered
//       which is not put into Stack
void
Read_In_Expression(Stack_T Stack) {
	ArithToken_T ArithToken;
	BOOLEAN	Q_OK;

	Flush_For_Read();
	Read_Rec(ArithToken, Q_OK);
	if (Q_OK) {
		if (!Q_NL(ArithToken)) {
			Push(ArithToken, Stack);
		}
		for(;(!Q_NL(ArithToken)) && (Q_OK);) {
			Read_Rec(ArithToken, Q_OK);
			if (Q_OK) {
				if (!Q_NL(ArithToken)) {
					Push(ArithToken, Stack);
				}
			}
			else {
				cout	<< "\nInvalid Token Type\n";
			}
		}
	}
	else {
		cout	<< "\nInvalid Token Type\n";
	}
}


// PRE	Input stream contains a syntactically
//			correct infix arithemtic expression Expr
//			optionally separated only by spaces and tabs
//			and terminated by a NL
// POST	Stack contains the equivalnet postfix version of Expr
void
Read_Infix_To_Postfix(Stack_T Stack) {

	Stack_T 		Siding,
					Out;
	ArithToken_T	ArithToken,
					SidingArithToken;
	BOOLEAN		Q_OKRead,
					Q_OPLessPrec;

	Siding = Create_Stack();
	Out = Create_Stack();

	Flush_For_Read();
	Read_Rec(ArithToken, Q_OKRead);
	for(;(!Q_NL(ArithToken));) {

		if (Q_Int(ArithToken)) {
			Push(ArithToken, Out);
		}
		if (Q_LRB(ArithToken)) {
			Push(ArithToken, Siding);
		}
		if (Q_RRB(ArithToken)) {
			SidingArithToken = Top(Siding);
			Pop(Siding);
			for(;!Q_LRB(SidingArithToken);) {
				Push(SidingArithToken, Out);
				SidingArithToken = Top(Siding);
				Pop(Siding);
			}
		}
		if(Q_Op(ArithToken)) {
			Q_OPLessPrec = FALSE;
			if (Q_EmptyStack(Siding)) {
				Push(ArithToken, Siding);
			}
			else {
				SidingArithToken = Top(Siding);
				for(;	(!Q_EmptyStack(Siding)) &&
						(!Q_LRB(SidingArithToken)) &&
						(!Q_OPLessPrec);) {

					if (Get_Precedence(ArithToken) > Get_Precedence(SidingArithToken)) {
						Q_OPLessPrec = TRUE;
					}
					else {
						Push(SidingArithToken, Out);
						Pop(Siding);
					}
					if (!Q_EmptyStack(Siding)) {
						SidingArithToken = Top(Siding);
					}
				}
				Push(ArithToken, Siding);
			}
		}

		// This code is to show the
		// conversion process
		cout	<< "\nToken is ";
		Write_Rec(ArithToken);
		cout	<< "\tOut is ";
		Print_Stack(Out);
		cout	<< "\tSiding is ";
		Print_Stack(Siding);
		// END This code is to show the
		// conversion process

		Read_Rec(ArithToken, Q_OKRead);
	}
	if (Q_OKRead) {
		for(;!Q_EmptyStack(Siding);) {
			SidingArithToken = Top(Siding);
			Pop(Siding);
			Push(SidingArithToken, Out);

			// This code is to show the
			// conversion process
			cout	<< "\nToken is ";
			Write_Rec(ArithToken);
			cout	<< "\tOut is ";
			Print_Stack(Out);
			cout	<< "\tSiding is ";
			Print_Stack(Siding);
			// END This code is to show the
			// conversion process
		}
	}

	// This will be needed to clear up
	// if the input was not a valid infix expression
	for(;!Q_EmptyStack(Stack);) {
		Pop(Stack);
	}

	for(;!Q_EmptyStack(Out);) {
		ArithToken = Top(Out);
		Push(ArithToken, Stack);
		Pop(Out);
	}

	Free_Stack(Siding);
	Free_Stack(Out);
}

// PRE	Stack contains a syntactically correct post fix expression Expr
// POST	Stack contains just one element - the value of Expr
void
Eval_Stack(Stack_T Stack) {

	Stack_T Temp;
	ArithToken_T	ArithToken,
					Operand1,
					Operand2,
					Result;

	Temp = Create_Stack();
	cout	<< "\nStack is ";
	Print_Stack(Stack);

	for(;(!Q_EmptyStack(Stack));) {
		ArithToken = Top(Stack);
		Pop(Stack);
		if (Q_Int(ArithToken)) {
			Push(ArithToken, Temp);
		}
		else {
			Operand2 = Top(Temp);
			Pop(Temp);
			Operand1 = Top(Temp);
			Pop(Temp);
			Result = Evaluate(Operand1, ArithToken, Operand2);
			Push(Result, Temp);
		}

		// This code is to show the
		// evaluation process
		cout	<< "\nStack is ";
		Print_Stack(Stack);
		cout	<< "\tTemp is ";
		Print_Stack(Temp);
		// END This code is to show the
		// evaluation process

	}
	Result = Top(Temp);
	Pop(Temp);
	Free_Stack(Temp);
	Push(Result, Stack);
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	test to see if stack is (e)mpty *********\n"
			<<	"***	(r)ead in expression       **************\n"
			<<	"***	(p)rint stack              **************\n"
			<<	"***	read and (c)onvert infix to postfix   **************\n"
			<<	"***	(e)valuate stack       **************\n"
			<< "***  (m)enu						   **************\n"
			<< "***  e(x)it						   **************\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise(Stack_T *Stack_Ptr) {

	(*Stack_Ptr) = Create_Sequence();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(Stack_T Stack) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'r' :	Read_In_Expression(Stack);
				break;
			case 'p' :	Print_Stack(Stack);
				break;
			case 'c' :	Read_Infix_To_Postfix(Stack);
				break;
			case 'e' :	Eval_Stack(Stack);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(Stack_T Stack) {
	for(;!Q_EmptyStack(Stack);) {
		Delete_Current(Stack);
	}
	Free_Stack(Stack);
	cout	<< "That is it !\n";
}


void
main() {
	Stack_T	Stack;

	Initialise(&Stack);
	Loop(Stack);
	Finalise(Stack);
}