// read_in.cpp
// 7/8/98
// Demonstrates use of Stack_T with Element_T = char
// Ken Brownsey

#include <iostream.h>
#include "stack.h"

typedef Stack_T Stack_T;

// PRE	TRUE
// POST	Stack printed out in order of recentness
void
Print_Stack(Stack_T Stack) {
	Stack_T	Temp;
	char	NextChar;

	Temp = Create_Stack();
	for(;!Q_EmptyStack(Stack);) {
		NextChar = Top(Stack);
		Push(NextChar, Temp);
		Pop(Stack);
		cout	<<	NextChar
				<< ' ';
	}
	for(;!Q_EmptyStack(Temp);) {
		NextChar = Top(Temp);
		Push(NextChar, Stack);
		Pop(Temp);
	}
	Free_Stack(Temp);
}





// PRE	TRUE
// POST  Reads in up to new line, deleting with # sign
void
Read_Into_Stack(Stack_T Stack) {
	char	NextChar;

	cin	>>	NextChar;
	// Throw away any odd newlines hanging around
	for(;NextChar == '\n';) {
		cin.get(NextChar);
	}
	for(;NextChar != '\n';) {
		cout	<< "\nStack is ";
		Print_Stack(Stack);
		cout	<< "\tNextChar is "
				<< NextChar;

		if (NextChar != '#') {
			Push(NextChar, Stack);
		}
		else {
			if (!Q_EmptyStack(Stack)) {
				Pop(Stack);
			}
		}
      // cin.get takes note of \n's but cin does not
		cin.get(NextChar);
	}
	cout	<< "\n\tFinal stack is ";
	Print_Stack(Stack);
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	(r)ead into stack       **************\n"
			<< "***	(p)rint out stack          **************\n"
			<< "***  (m)enu						   **************\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise(Stack_T &Stack) {

	Stack = Create_Stack();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(Stack_T Stack) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'r' :	Read_Into_Stack(Stack);
				break;
			case 'p' :	Print_Stack(Stack);
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(Stack_T Stack) {
	for(;!Q_Empty(Stack);) {
		Delete_Current(Stack);
	}
	Free_Stack(Stack);
	cout	<< "That is it !\n";
}


void
main() {
	Stack_T	Stack;

	Initialise(Stack);
	Loop(Stack);
	Finalise(Stack);
}