// queue.h
// 7/8/98
// Ken Brownsey

#include "my_const.h"


typedef char QueueElement;
typedef void *Queue_T;

// PRE	TRUE
// POST	RETURNS an initialised Queue_T
Queue_T
Create_Queue();

// PRE	NOT Q_FullQueue(Queue)
// POST 	elements of Queue' = elements of Queue union {Element}
void
EnQueue(QueueElement NewElement, Queue_T Queue);

// PRE	TRUE
// POST	IF Queue is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyQueue(Queue_T Queue);



// PRE	NOT Q_EmptyQueue(Queue)
// POST	Queue' is Queue with the most recently entered
//			element removed
void
DeQueue(Queue_T Queue);


// PRE	NOT Q_EmptyQueue(Queue)
// POST	RETURNS the value of the least recently
//				entered element of Queue *)
QueueElement
Front(Queue_T Queue);


//	PRE	Q_EmptyQueue(Queue)
//	POST	all memory allocated to Queue is freed up
// NOTES	Queue will need to be re-initialised
//			with Create_Queue() before being used again
void
Free_Queue(Queue_T Queue);
