// qu_demo.cpp
// 8/8/98
// Demonstrates use of Queue_T with Element_T = char
// Ken Brownsey

#include <iostream.h>
#include "queue.h"


// PRE	TRUE
// POST	IF Q_EmptyQueue(Queue)
//				Message to say so
//			ELSE
//				Message to say not empty
void
Test_Empty(Queue_T Queue) {
	if (Q_EmptyQueue(Queue)) {
		cout	<< "\nQueue is empty\n";
	}
	else  {
		cout	<< "\nQueue is not empty\n";
	}
}


// PRE	TRUE
// POST  IF NOT Q_Full(Queue) THEN
//				user is prompted for Symbol
//				Queue' = Push(Symbol, Queue)
//			ELSE appropriate message
void
Add_To_Queue(Queue_T Queue) {
	char	Symbol;

	cout	<< "Please type in new record\n";
	cin	>>	Symbol;
	EnQueue(Symbol, Queue);
}


// PRE	TRUE
// POST  IF NOT Q_EmptyQueue(Queue) THEN
//				Queue' = Delete_Current(Queue)
//			ELSE appropriate message
void
Remove_Front(Queue_T Queue) {

	if (Q_EmptyQueue(Queue)) {
		cout	<< "Queue is empty";
	}
	else {
		DeQueue(Queue);
	}
}


// PRE	TRUE
// POST  IF NOT Q_EmptyQueue(Queue) THEN
//				current element is printed to screen
//			ELSE appropriate message
void
Print_Front(Queue_T Queue) {

	if (Q_EmptyQueue(Queue)) {
		cout	<< "Queue is empty";
	}
	else {
		cout	<<	Front(Queue);
	}
}


// PRE	TRUE
// POST  all elements of Queue printed to screen
void
Print_All_R(Queue_T Queue) {
	char	Symbol;

	if (!Q_EmptyQueue(Queue)) {
		Symbol = Front(Queue);
		cout	<<	Symbol
				<<	" ";
		DeQueue(Queue);
		Print_All_R(Queue);
		EnQueue(Symbol, Queue);
	}
}


// PRE	TRUE
// POST  elements of Queue are reversed
void
Reverse_R(Queue_T Queue) {
	char	Symbol;

	if (!Q_EmptyQueue(Queue)) {
		Symbol = Front(Queue);
		DeQueue(Queue);
		Reverse_R(Queue);
		EnQueue(Symbol, Queue);
	}
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	test to see if queue is (e)mpty *********\n"
			<<	"***	e(n)queue new record to queue **********\n"
			<<	"***	(d)eque oldest element       **************\n"
			<< "***	print(f)ront element          **************\n"
			<< "***	(s)how all elements          **************\n"
			<< "***  (m)enu						   **************\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise(Queue_T *Queue_Ptr) {

	(*Queue_Ptr) = Create_Queue();
	cout	<< "Here we go !\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(Queue_T Queue) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'e' :	Test_Empty(Queue);
				break;
			case 'n' :	Add_To_Queue(Queue);
				break;
			case 'd' :	Remove_Front(Queue);
				break;
			case 'f' :	Print_Front(Queue);
				break;
			case 's' :	Print_All_R(Queue);
							Reverse_R(Queue);
				break;
			case 'm' : Menu();
				break;
			case 'x' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(Queue_T Queue) {
	for(;!Q_EmptyQueue(Queue);) {
		DeQueue(Queue);
	}
	Free_Queue(Queue);
	cout	<< "That is it !\n";
}


void
main() {
	Queue_T	Queue;

	Initialise(&Queue);
	Loop(Queue);
	Finalise(Queue);
}