// fact.cpp
// 19/8/98
// Demonstrates the factorial function
// Ken Brownsey
#include <iostream.h>



// PRE	n >= 0
// POST	RETURNS n!
int
Factorial_R(int n) {
	if (n == 0) {
		return(1);
	}
	else {
		return(n*Factorial_R(n-1));
	}
}


// PRE	n >= 0
// POST	RETURNS n!
int
I_Factorial(int n) {
int	Index,
		Result;

		Result = 1;
		for(Index = 1; Index <= n; Index++) {
			Result = Result*Index;
		}
		return(Result);
}


// PRE	n >= 0
// POST	RETURNS n!
int
Show_Factorial_R(int n) {
	int	Next;
	cout	<< "\n Calling Factorial_R n is "
			<< n;
	if (n == 0) {
		Next = 1;
		cout	<< "\n Exiting Factorial_R  n is "
				<< n
				<< " returning "
				<< Next;
		return(Next);
	}
	else {
		Next = n*Show_Factorial_R(n-1);
		cout	<< "\n Exiting Factorial_R  n is "
				<< n
				<< " returning "
				<< Next;
		return(Next);
	}
}



// PRE	TRUE
// POST	Prompts for non-negative integer
//			AND 	IF input is not negative
//             	RETURNS factorial of input
void
Do_RecursiveFactorial() {
	int	Val;

	cout	<< "\nPlease type in a non-negative integer";
	cout	<< "\n==> ";
	cin	>> Val;
	if (Val >= 0) {
		cout	<< "\n\n"
				<< Val
				<< "! (or factorial) is "
				<< Factorial_R(Val)
				<< "\n\n";
	}
	else {
		cout	<< "\nNeed number >= 0";
	}
}


// PRE	TRUE
// POST	Prompts for non-negative integer
//			AND 	IF input is not negative
//             	RETURNS factorial of input
void
Do_IterativeFactorial() {
	int	Val;

	cout	<< "\nPlease type in a non-negative integer";
	cout	<< "\n==> ";
	cin	>> Val;
	if (Val >= 0) {
		cout	<< "\n\n"
				<< Val
				<< "! (or factorial) is "
				<< I_Factorial(Val)
				<< "\n\n";
	}
	else {
		cout	<< "\nNeed number >= 0";
	}
}


// PRE	TRUE
// POST	Prompts for non-negative integer
//			AND 	IF input is not negative
//             	RETURNS factorial of input
//						showing steps in recurisve evaluation
void
Show_RecursiveFactorial() {
	int	Val;

	cout	<< "\nPlease type in a non-negative integer";
	cout	<< "\n==> ";
	cin	>> Val;
	if (Val >= 0) {
		cout	<< "\n\n"
				<< Val
				<< "! (or factorial) is "
				<< Show_Factorial_R(Val)
				<< "\n\n";
	}
	else {
		cout	<< "\nNeed number >= 0";
	}
}

// PRE	TRUE
// POST	Message about program printed to screen
void
Initialise() {
	cout	<< "\nThe Magnificent Factorial Program\n\n";
}


// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	(r)ecursive factorial       	**************\n"
			<< "***	(i)terative factorial		  	**************\n"
			<<	"***	(s)how recursive factorial    **************\n"
			<< "***  (m)enu						   	**************\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop() {

	char	Request;
	int	RequestCount;


	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'r' :	Do_RecursiveFactorial();
				break;
			case 'i' :	Do_IterativeFactorial();
				break;
			case 's' :	Show_RecursiveFactorial();
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Announces departure
void
Finalise() {
	cout	<< "That is it !\n";
}


void
main() {
	Initialise();
	Loop();
	Finalise();
}
