// hanoi.h
// 16/8/98
// Demonstrates recursion in Hanoi problem solving
//	with Element_T = int
// Ken Brownsey

#include <iostream.h>
#include "stack.h"

typedef Stack_T Hanoi_T[3];
typedef enum Peg_T {A, B, C};
typedef enum Direction_T {ClockWise, AntiClockWise};
typedef Element_T Disc_T;

// SECTION 1 - Operations on Peg_T ADT

// PRE	TRUE
// POST	RETURNS next peg after peg in direction Direction
Peg_T
Next_Peg(Peg_T Peg, Direction_T Direction);

// ENDSECTION 1 - Operations on Peg_T ADT



// SECTION 2 - Operations on Stack_T ADT

// END SECTION 2 - Operations on Stack_T ADT


// SECTION 3 - Operations on Hanoi_T ADT

// PRE	Peg1 and Peg2 of Hanoi not empty
// POST	IF disc on Peg1 bigger than that on Peg2
//				RETURNS TRUE
// 		ELSE
//				RETURNS FALSE
BOOLEAN
Q_BiggerDisc(Peg_T Peg1, Peg_T Peg2, Hanoi_T Hanoi);


// PRE	Peg1 and Peg2 of Hanoi not empty
// POST	IF disc on Peg1 bigger than that on Peg2
//				RETURNS TRUE
// 		ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyPeg(Peg_T Peg, Hanoi_T Hanoi);


// PRE	TRUE
// POST	Towers of Hanoi printed to screen (left is top)
void
Print_Hanoi(Hanoi_T Hanoi);

// PRE 	TRUE
// POST  Top disc moved from FromPeg to ToPeg
//			AND message written to screen
//			0 ==> A, 1 ==> B, 2 ==> C for pegs
void
Move_Disc(Peg_T FromPeg, Peg_T ToPeg, Hanoi_T Hanoi);

// PRE	TRUE
// POST	Hanoi with NumDiscs set up as problem
void
Reset_Hanoi(Hanoi_T Hanoi, int NumDiscs);

// END SECTION 3 - Operations on Hanoi_T ADT

