// utildemo.cpp
// 23/8/98
// Demonstrates recursive high level procedures on Stack_T
// Ken Brownsey

#include "rec_util.h"
#include <stdlib.h>
#define MaxSize 100
#define MaxEl 99
#define MaxStacks 6

typedef Stack_T StackArray_T[MaxStacks];

// PRE	TRUE
// POST  Prompts for stack number in Stacks
//			IF in range
//				prompts for number of elements
//				and sets up random stack in Stacks
//			ELSE
//				out of range message
void
Set_Up_Stack(StackArray_T Stacks) {

	int	StackNum,
			NumEls,
			Index;
	Element_T NextEl;
	int	Seed;

	cout	<< "\nWhich stack is to be set up 0 to "
			<< (MaxStacks - 1)
			<< "==> ";
	cin	>> StackNum;

	if ((StackNum >= 0) && (StackNum < MaxStacks)) {
		Make_Empty_R(Stacks[StackNum]);
		cout	<< "\nYou can have up to "
				<<	MaxSize
				<<	" elements ";
		cout	<< "\nHow many elements ==> ";
		cin	>> NumEls;
		if (NumEls <= MaxSize) {
			cout	<< "\nPlease type in any number ==> ";
			cin	>> Seed;
			srand(Seed);
			for(Index = 1; Index <= NumEls; Index++) {
				NextEl = rand() % MaxEl + 1;
				Push(NextEl, Stacks[StackNum]);
			}
			cout	<< "\n Stack is as follows \n";
			Print_Stack_R(Stacks[StackNum]);
		}
		else {
			cout	<< NumEls
					<<	" is more than "
					<<	MaxSize;
		}
	}
	else {
		cout	<< "\nOut of range stack number ==> "
				<< StackNum;
	}
}


// PRE	TRUE
// POST  Prompts for stack number in Stacks
//			IF in range
//				IF it is not empty
//					prints it to screen
//         	ELSE
//					Message to say it is empty
//			ELSE
//				out of range message
void
Print_One_Stack(StackArray_T Stacks) {

	int	StackNum;

	cout	<< "\nWhich stack is to be printed 0 to "
			<< (MaxStacks - 1)
			<< "==> ";
	cin	>> StackNum;
	if ((StackNum >= 0) && (StackNum < MaxStacks)) {
		if (!Q_EmptyStack(Stacks[StackNum])) {
			Print_Stack_R(Stacks[StackNum]);
		}
		else {
			cout	<< "\nStack number "
					<< StackNum
					<< " is empty\n";
		}
	}
	else {
		cout	<< "\nOut of range stack number ==> "
				<< StackNum;
	}
}



// PRE	TRUE
// POST  Prompts for stack number in Stacks
//			IF in range
//				IF it is not empty
//					prints size to screen
//         	ELSE
//					Message to say it is empty
//			ELSE
//				out of range message
void
Find_How_Big(StackArray_T Stacks) {

	int	StackNum;

	cout	<< "\nWhich stack's size is to be printed 0 to "
			<< (MaxStacks - 1)
			<< "==> ";
	cin	>> StackNum;
	if ((StackNum >= 0) && (StackNum < MaxStacks)) {
		if (!Q_EmptyStack(Stacks[StackNum])) {
			cout	<< "\nSize of stack number "
					<< StackNum
					<< " is "
					<< Get_Size_R(Stacks[StackNum]);
		}
		else {
			cout	<< "\nStack number "
					<< StackNum
					<< " is empty\n";
		}
	}
	else {
		cout	<< "\nOut of range stack number ==> "
				<< StackNum;
	}
}



// PRE	TRUE
// POST  Prompts for stack number in Stacks and element
//			IF in range
//				IF element is in stack
//            	Message to say so
//				ELSE
//					Message to say not
//			ELSE
//				out of range message
void
Check_Membership(StackArray_T Stacks) {

	int	StackNum;
	Element_T Element;

	cout	<<	"\nType in element to be checked for ==> ";
	cin	>> Element;
	cout	<< "\nWhich stack is to be checked 0 to "
			<< (MaxStacks - 1)
			<< " ==> ";
	cin	>> StackNum;

	if ((StackNum >= 0) && (StackNum < MaxStacks)) {
		if (Q_Member_R(Element, Stacks[StackNum])) {
			cout	<< "\n"
					<< Element
					<< " is a member of \n";
			Print_Stack_R(Stacks[StackNum]);
		}
		else {
			cout	<< "\n"
				<< Element
				<< " is not a member of \n";
			Print_Stack_R(Stacks[StackNum]);
		}
	}
	else {
		cout	<< "\nOut of range stack number ==> "
				<< StackNum;
	}
}


// PRE	TRUE
// POST  Prompts for stack number in Stacks and element
//			IF in range
//				element is deleted from Stack, if present
//			ELSE
//				out of range message
void
Delete_Element(StackArray_T Stacks) {

	int	StackNum;
	Element_T Element;

	cout	<<	"\nType in element to be deleted ==> ";
	cin	>> Element;
	cout	<< "\nWhich stack is it to be deleted from 0 to "
			<< (MaxStacks - 1)
			<< " ==> ";
	cin	>> StackNum;

	if ((StackNum >= 0) && (StackNum < MaxStacks)) {
		cout	<< "\nOriginal stack is \n";
		Print_Stack_R(Stacks[StackNum]);
		Delete_R(Element, Stacks[StackNum]);
		cout	<< "\n\nNow it is \n";
		Print_Stack_R(Stacks[StackNum]);
	}
	else {
		cout	<< "\nOut of range stack number ==> "
				<< StackNum;
	}
}


// PRE	TRUE
// POST  Prompts for stack number in Stacks
//			IF in range
//				Prompts for second stack number in stacks
//				IF in range
//					Second stack is emptied
//					First stack is copied to second stack
//				ELSE
//        		out of range message
//			ELSE
//				out of range message
void
Copy_Stack(StackArray_T Stacks) {

	int	StackNum1,
			StackNum2;

	cout	<< "\nWhich stack is to be copied 0 to "
			<< (MaxStacks - 1)
			<< "==> ";
	cin	>> StackNum1;

	if ((StackNum1 >= 0) && (StackNum1 < MaxStacks)) {
		cout	<< "\nWhich stack is be the copy 0 to "
				<< (MaxStacks - 1)
				<< "==> ";
		cin	>> StackNum2;
		if ((StackNum2 >= 0) && (StackNum2 < MaxStacks)) {
			Make_Empty_R(Stacks[StackNum2]);
			Stacks[StackNum2] = Copy_Stack_R(Stacks[StackNum1]);
			cout	<< "\nOriginal stack was\n";
			Print_Stack_R(Stacks[StackNum1]);
			cout	<< "\nCopy stack is\n";
			Print_Stack_R(Stacks[StackNum2]);
		}
		else {
			cout	<< "\nOut of range stack number for copy stack ==> "
					<< StackNum1;
		}
	}
	else {
		cout	<< "\nOut of range stack number for stack to be copied ==> "
				<< StackNum1;
	}
}



// PRE	TRUE
// POST  Prompts for stack number in Stacks
//			IF in range
//				Prompts for second stack number in stacks
//				IF in range
//					Second stack is emptied
//					Comnplement of first stack with respect
//					to second stack is printed to screen
//				ELSE
//        		out of range message
//			ELSE
//				out of range message
void
WorkOut_Complement(StackArray_T Stacks) {

	int	StackNum1,
			StackNum2,
			StackNum3;
	Stack_T 	CopyOfStack2,
				Result;

	cout	<< "\nWhich stack is to be be complemented 0 to "
			<< (MaxStacks - 1)
			<< "==> ";
	cin	>> StackNum1;

	if ((StackNum1 >= 0) && (StackNum1 < MaxStacks)) {
		cout	<< "\nWhich stack is it to be complemented wrt 0 to "
				<< (MaxStacks - 1)
				<< "==> ";
		cin	>> StackNum2;
		if ((StackNum2 >= 0) && (StackNum2 < MaxStacks)) {
			CopyOfStack2 = Copy_Stack_R(Stacks[StackNum2]);
			Result = Complement_R(Stacks[StackNum1], CopyOfStack2);
			cout	<< "\nComplement of\n";
			Print_Stack_R(Stacks[StackNum1]);
			cout	<< "\nwith respect to\n";
			Print_Stack_R(Stacks[StackNum2]);
			cout	<< "\nis\n";
			Print_Stack_R(Result);
			cout	<< "\n";
			cout	<< "\nWhich stack is result to be put in 0 to "
				<< (MaxStacks - 1)
				<< "==> ";
			cin	>> StackNum3;
			if ((StackNum3 >= 0) && (StackNum3 < MaxStacks)) {
				Make_Empty_R(Stacks[StackNum3]);
				Stacks[StackNum3] = Copy_Stack_R(Result);
			}
			else {
				cout	<< "\nOut of range stack number for third stack ==> "
				<< StackNum1;
			}
			Make_Empty_R(Result);
			Make_Empty_R(CopyOfStack2);
		}
		else {
			cout	<< "\nOut of range stack number for second stack ==> "
					<< StackNum1;
		}
	}
	else {
		cout	<< "\nOut of range stack number for first stack ==> "
				<< StackNum1;
	}
}



// PRE  -	TRUE
// POST -	menu displayed
void
Menu() {
	cout	<<	"***	(s)et up stack      ******************\n"
			<<	"***	(p)rint stack        *****************\n"
			<<	"***	how (b)ig is stack        ************\n"
			<<	"***	(c)opy stack        ******************\n"
			<<	"***	(t)est membership of stack ***********\n"
			<<	"***	(d)elete element from stack **********\n"
			<<	"***	(w)ork out complement       **********\n"
			<<	"***	show st(a)ts                **********\n"
			<< "***  (m)enu						  ************\n"
			<< "***  e(x)it						  ************\n";
}


// PRE	TRUE
// POST	Initialisation is done
void
Initialise(StackArray_T &Stacks) {
	int Index;

	for(Index = 0; Index < MaxStacks; Index++) {
		Stacks[Index] = Create_Stack();
	}
	cout	<< "Here we go !\n";
}



// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(StackArray_T Stacks) {

	char	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 's' :	Set_Up_Stack(Stacks);
				break;
			case 'p' :	Print_One_Stack(Stacks);
				break;
			case 'b' :	Find_How_Big(Stacks);
				break;
			case 'c' :	Copy_Stack(Stacks);
				break;
			case 't' :	Check_Membership(Stacks);
				break;
			case 'd' :	Delete_Element(Stacks);
				break;
			case 'w' :	WorkOut_Complement(Stacks);
				break;
			case 'a' :	StackStats();
				break;
			case 'm' : Menu();
				break;
			default   :
				cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;
	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise() {
	cout	<< "That is it !\n";
}


void
main() {
	StackArray_T	Stacks;

	Initialise(Stacks);
	Loop(Stacks);
	Finalise();
}