// stack.cpp
// 7/8/98
// Stack_T based on Sequence_T
// Ken Brownsey

#include "stack.h"
#include <iostream.h>

int	PushCount = 0,
		PopCount = 0;

// PRE	TRUE
// POST	RETURNS an initialised Stack_T
Stack_T
Create_Stack() {
	return(Create_Sequence());
}


// PRE	NOT Q_FullStack(Stack)
// POST 	elements of Stack' = elements of Stack union {Element}
void
Push(Element_T NewElement, Stack_T Stack) {
	if (Q_Empty(Stack)) {
		Append_After_Current(NewElement, Stack);
	}
	else {
		Insert_Before_Current(NewElement, Stack);
		Go_To_Head(Stack);
	}
	PushCount++;
}


// PRE	TRUE
// POST	IF Stack is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyStack(Stack_T Stack) {
	return(Q_Empty(Stack));
}


// PRE	TRUE
// POST	IF Stack is full
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_FullStack(Stack_T Stack) {
	return(Q_Full(Stack));
}


// PRE	NOT Q_EmptyStack(Stack)
// POST	Stack' is Stack with the most recently entered
//			element removed
void
Pop(Stack_T Stack) {
	Delete_Current(Stack);
	PopCount++;
}


// PRE	NOT Q_EmptyStack(Stack)
// POST	RETURNS the value of the most recently
//				entered element of Stack *)
Element_T
Top(Stack_T Stack) {
	return(Get_Current(Stack));
}



//	PRE	Q_EmptyStack(Stack)
//	POST	all memory allocated to Stack is freed up
// NOTES	Stack will need to be re-initialised
//			with Create_Stack() before being used again
void
Free_Stack(Stack_T Stack) {
	Free_Sequence(Stack);
}

// PRE	TRUE
// POST	Prints out statistics
void
StackStats() {
	cout	<< "\nPushes ==> "
			<< PushCount
			<< "\nPops ==> "
			<< PopCount
			<< "\nPushes minus pops ==> "
			<< (PushCount - PopCount);
}
