// Ken Brownsey
// 31/8/98
// rec_tree.h
// Generic structural ADT recursive tree
// A binary tree is either the empty tree
// or an element, the root, and two binary trees
// the left sub tree and the right sub tree

#include "data.h"
#include "my_const.h"

#ifndef REC_TREE_H
#define REC_TREE_H


typedef DataRec_T Element_T;

typedef void  *BT_T;

// PRE	TRUE
// POST	RETURNS the empty tree
BT_T
Create_Tree();


// PRE	TRUE
// POST	IF Tree is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyTree(BT_T Tree);


// PRE  	NOT Q_EmptyTree(Tree)
// POST	RETURNS the root record
Element_T
Get_Root(BT_T Tree);


// PRE	TRUE
// POST	IF NOT Q_EmptyTree(Tree)
//				RETURNS the left sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BT_T
Get_Left(BT_T Tree);


// PRE	TRUE
// POST	IF NOT Q_EmptyTree(Tree)
//				RETURNS the right sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BT_T
Get_Right(BT_T Tree);


// PRE	TRUE
// POST	RETURNS the tree whose root is Root,
//				left sub tree is Left,
//				right sub tree is Right
BT_T
Make_Tree(BT_T Left, Element_T Element, BT_T Right);



#endif