// Ken Brownsey
// 31/8/98
// rec_tree.cpp
// Generic structural ADT recursive tree
// A binary tree is either the empty tree
// or an element, the root, and two binary trees
// the left sub tree and the right sub tree

#include "rec_tree.h"

// node structure for linked tree
typedef struct TN_T {
	struct TN_T	*Left_Ptr,
					*Right_Ptr;
	Element_T	DataRec;
} Node_T, *Node_Ptr_T;

int	NumberAllocated = 0;


// PRE	TRUE
// POST	RETURNS the empty tree
BT_T
Create_Tree() {
	return(NULL);
}


// PRE	TRUE
// POST	IF Tree is empty RETURNS TRUE ELSE RETURNS FALSE
BOOLEAN
Q_EmptyTree(BT_T Tree) {
	return(Tree == NULL);
}


// PRE  	Tree is not empty
// POST	RETURNS the root record
Element_T
Get_Root(BT_T Tree) {
	Node_Ptr_T	Node_Ptr;

	Node_Ptr = (Node_Ptr_T) Tree;

	return(Node_Ptr->DataRec);
}


// PRE	TRUE
// POST	IF Tree is not empty
//				RETURNS the left sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BT_T
Get_Left(BT_T Tree) {
	Node_Ptr_T	Node_Ptr;

	Node_Ptr = (Node_Ptr_T) Tree;

	if (Node_Ptr == NULL) {
		return(NULL);
	}
	else {
		return((void *) Node_Ptr->Left_Ptr);
	}
}


// PRE	TRUE
// POST	IF Tree is not empty
//				RETURNS the right sub tree of Tree
//			ELSE
//				RETURNS the empty tree
BT_T
Get_Right(BT_T Tree) {
	Node_Ptr_T	Node_Ptr;

	Node_Ptr = (Node_Ptr_T) Tree;

	if (Node_Ptr == NULL) {
		return(NULL);
	}
	else {
		return((void *) Node_Ptr->Right_Ptr);
	}
}


// PRE	TRUE
// POST	RETURNS the tree whose root is Root,
//				left sub tree is Left,
//				right sub tree is Right
BT_T
Make_Tree(BT_T Left, Element_T Element, BT_T Right) {

	Node_Ptr_T	NewTree;

	NewTree = new Node_T;
	NumberAllocated++;
	NewTree->DataRec = Element;
	NewTree->Left_Ptr = (Node_Ptr_T) Left;
	NewTree->Right_Ptr = (Node_Ptr_T) Right;
	return((void *) NewTree);
}


// PRE  - 	TRUE
// POST - 	RETURNS the number of nodes allocated

Get_NumberNodes_Allocated() {
	return(NumberAllocated);
}


