// treedemo.cpp
// 31/8/98
// Demonstrates binary search tree
// Ken Brownsey

#include "bst_util.h"
#include <iostream.h>

#define ReqSize	20


// Global list
BST_T		DataBase;

// PRE	TRUE
// POST	user is prompted for record
//			IF record is not in DBase
//				it is added to DBase
//			ELSE
//				appropriate message
void
Add_New_Record(BST_T &DBase) {

	Element_T	DataRec;

	cout	<< "\nType record in\n";
	Read_Rec(DataRec);
	if (!Q_BST_Present_R(Get_Key(DataRec), DBase)) {
		DBase = BST_Insert_R(DataRec, DBase);
	}
	else {
		cout	<<	"\nRecord with key ";
		Write_Key(Get_Key(DataRec));
		cout	<< " is already in database\n";
	}
}


// PRE	TRUE
// POST	user is prompted for key value
//			IF record with that key is in DBase
//				message to say so
//			ELSE
//				message to say not
void
Check_Key_Present(BST_T DBase) {

	Key_T	Key;

	cout	<< "\nType key to be checked for ==> ";
	Key = Read_Key();
	if (Q_BST_Present_R(Key, DBase)) {
		cout	<<	"\nKey value ";
		Write_Key(Key);
		cout	<<	" is present in the database\n";
	}
	else {
		cout	<<	"\nKey value ";
		Write_Key(Key);
		cout	<<	" is not present in the database\n";
	}
}


// PRE	TRUE
// POST	IF NOT Q_EmptyTree(DBase)
//				user is prompted for key value
//				IF record with that key is in DBase
//					record is printed to screen
//				ELSE
//					message to say record not present
//			ELSE
//				message to say DBase is empty
void
Get_Record(BST_T DBase) {

	Key_T	Key;

	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nType key of record to be retrieved ==> ";
		Key = Read_Key();
		if (Q_BST_Present_R(Key, DBase)) {
			cout	<<	"\nRecord is \n ";
			Write_Rec(BST_Retrieve_R(Key, DBase));
			cout	<<	"\n";
		}
		else {
			cout	<<	"\nKey value ";
			Write_Key(Key);
			cout	<<	" is not present in the database\n";
		}
	}
	else {
		cout	<<	"\nDatabase is empty\n\n";
	}
}


// PRE	TRUE
// POST	IF NOT Q_EmptyTree(DBase)
//				user is prompted for key value
//				IF record with that key is in DBase
//					record is printed to screen
//				ELSE
//					message to say record not present
//			ELSE
//				message to say DBase is empty
void
Erase_Record(BST_T &DBase) {

	Key_T	Key;

	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nType key of record to be erased ==> ";
		Key = Read_Key();
		if (Q_BST_Present_R(Key, DBase)) {
			DBase = BST_Delete_R(Key, DBase);
		}
		else {
			cout	<<	"\nKey value ";
			Write_Key(Key);
			cout	<<	" is not present in the database\n";
		}
	}
	else {
		cout	<<	"\nDatabase is empty\n\n";
	}
}


// PRE	TRUE
// POST	IF DataBase is not empty
//				it is printed in key order
void
Print_DataBase(BST_T DataBase) {

	if (Q_EmptyTree(DataBase)) {
		cout	<< "\n No records to print \n";
	}
	else {
		Print_Tree_R(DataBase);
	}
}


// PRE	TRUE
// POST	IF DBase is not empty
//				Tree diagram of DBase printed
//			ELSE
//				Appropriate message
void
Show_DBase_Structure(BST_T DBase) {

	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nStructure of database is \n";
		Tree_Diagram_R(DBase, 0, 1);
	}
	else {
		cout	<< "\n\nNo elements in database";
	}
}


// PRE	TRUE
// POST IF NOT Q_EmptyTree THEN
//			prints out size of tree
//		ELSE
//			empty tree message
void
Print_Size(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nSize is "
				<< Size_R(DBase)
				<< "\n";
	}
	else {
		cout	<< "\Database is empty\n";
	}
}


// PRE	TRUE
// POST IF NOT Q_EmptyTree THEN
//			prints out sum of elements in tree
//		ELSE
//			empty tree message
void
Print_Sum(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nSum of keys of elements is \n";
		Write_Key(Sum_R(DBase));
	}
	else {
		cout	<< "\Database is empty\n";
	}
}


// PRE	TRUE
// POST	Prints height of database tree to screen
void
Print_Height(BST_T DBase) {

	cout	<< "\nHeight of database is "
			<< Find_Depth_R(DBase)
			<< "\n";
}



// PRE	TRUE
// POST	IF DBase is not empty
//				prints out elements inorderwise
//			ELSE
//				appropriate message
void
Do_InOrder(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		InOrder_R(DBase);
	}
	else {
		cout	<< "\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST	IF DBase is not empty
//				prints out elements preorderwise
//			ELSE
//				appropriate message
void
Do_PreOrder(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		PreOrder_R(DBase);
	}
	else {
		cout	<< "\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST	IF DBase is not empty
//				prints out elements postorderwise
//			ELSE
//				appropriate message
void
Do_PostOrder(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		PostOrder_R(DBase);
	}
	else {
		cout	<< "\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST	traversal menu displayed
void
Traversal_Menu() {

	cout	<< "***   Traversal Options  	  *****************\n";
	cout	<< "***   (i)norder traversal  	  **************\n";
	cout	<< "***   p(r)int all records with brackets *****\n";
	cout	<< "***   (t)raversal menu 	  *****************\n";
	cout	<< "***   e(x)it to main menu	  	****************\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		for traversal options
//		until 'x' is the character read
void
Traversals(BST_T DBase) {

	char 	Request;
	static int	RequestCount = 0;

	for (Request = 'm'; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'i' : Do_InOrder(DBase);
				break;
			case 'e' : Do_PreOrder(DBase);
				break;
			case 'o' : Do_PostOrder(DBase);
				break;
			case 'r' : Print_DataBase(DBase);
				break;
			case 'm' : Traversal_Menu();
				break;
			default   : cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext traversal request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;

	}
}



// PRE	TRUE
// POST	menu displayed
void
Menu() {

	cout	<< "***   Main Menu            	  **************\n";
	cout	<< "***   (a)dd a new record  	  **************\n";
	cout	<< "***   check (k)ey present  	  **************\n";
	cout	<< "***   (g)et record         	  **************\n";
	cout	<< "***   (e)rase record       	  **************\n";
	cout	<< "***   print (s)ize of database **************\n";
	cout	<< "***   print s(u)m of keys in database      **\n";
	cout	<< "***   show (d)iagram of database  ***********\n";
	cout	<< "***   print (h)eight of database  ***********\n";
	cout	<< "***   show LR path for (p)ath and length  ***\n";
	cout	<< "***   (l)oad database from file  ************\n";
	cout	<< "***   (t)raversal options  ******************\n";
	cout	<< "***   (r)eset database **********************\n";
	cout	<< "***   this (m)enu	       	****************\n";
	cout	<< "***   e(x)it			        	****************\n";
}


// PRE	TRUE
// POST	DBase initialised
void
Initialise(BST_T &DBase) {

	DBase = Create_Tree();
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(BST_T DBase) {

	char 	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'a': Add_New_Record(DBase);
				break;
			case 'k': Check_Key_Present(DBase);
				break;
			case 'g': Get_Record(DBase);
				break;
			case 'e': Erase_Record(DBase);
				break;
			case 's': Print_Size(DBase);
				break;
			case 'u': Print_Sum(DBase);
				break;
			case 'l': Load_Tree_From_File(DBase);
				break;
			case 'd': Show_DBase_Structure(DBase);
				break;
			case 'p': Show_Path();
				break;
			case 'h': Print_Height(DBase);
				break;
			case 'r': Initialise(DBase);
				break;
			case 't' : Traversals(DBase);
				break;
			case 'm' : Menu();
				break;
			default   : cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;

	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(BST_T DBase) {
	cout	<< "That is it !";
}


void
main () {
	Initialise(DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}