// treedemo.cpp
// 31/8/98
// Demonstrates binary search tree
// Ken Brownsey

#include "bst_util.h"
#include <string.h>
#include "rd_str.h"
#include <iostream.h>

#define ReqSize	20


// Global list
BST_T		DataBase;

// PRE	TRUE
// POST	user is prompted for record
//			IF record is not in DBase
//				it is added to DBase
//			ELSE
//				appropriate message
void
Add_New_Record(BST_T &DBase) {

	Element_T	DataRec;

	cout	<< "\nType record in\n";
	Read_Rec(DataRec);
	if (!Q_BST_Present_R(Get_Key(DataRec), DBase)) {
		DBase = BST_Insert_R(DataRec, DBase);
	}
	else {
		cout	<<	"\nRecord with key ";
		Write_Key(Get_Key(DataRec));
		cout	<< " is already in database\n";
	}
}


// PRE	TRUE
// POST	user is prompted for key value
//			IF record with that key is in DBase
//				message to say so
//			ELSE
//				message to say not
void
Check_Key_Present(BST_T DBase) {

	Key_T	Key;

	cout	<< "\nType key to be checked for ==> ";
	Key = Read_Key();
	if (Q_BST_Present_R(Key, DBase)) {
		cout	<<	"\nKey value ";
		Write_Key(Key);
		cout	<<	" is present in the database\n";
	}
	else {
		cout	<<	"\nKey value ";
		Write_Key(Key);
		cout	<<	" is not present in the database\n";
	}
}


// PRE	TRUE
// POST	IF NOT Q_EmptyTree(DBase)
//				user is prompted for key value
//				IF record with that key is in DBase
//					record is printed to screen
//				ELSE
//					message to say record not present
//			ELSE
//				message to say DBase is empty
void
Get_Record(BST_T DBase) {

	Key_T	Key;

	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nType key of record to be retrieved ==> ";
		Key = Read_Key();
		if (Q_BST_Present_R(Key, DBase)) {
			cout	<<	"\nRecord is \n ";
			Write_Rec(BST_Retrieve_R(Key, DBase));
			cout	<<	"\n";
		}
		else {
			cout	<<	"\nKey value ";
			Write_Key(Key);
			cout	<<	" is not present in the database\n";
		}
	}
	else {
		cout	<<	"\nDatabase is empty\n\n";
	}
}


// PRE	TRUE
// POST	IF NOT Q_EmptyTree(DBase)
//				user is prompted for key value
//				IF record with that key is in DBase
//					record is printed to screen
//				ELSE
//					message to say record not present
//			ELSE
//				message to say DBase is empty
void
Erase_Record(BST_T &DBase) {

	Key_T	Key;

	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nType key of record to be erased ==> ";
		Key = Read_Key();
		if (Q_BST_Present_R(Key, DBase)) {
			DBase = BST_Delete_R(Key, DBase);
		}
		else {
			cout	<<	"\nKey value ";
			Write_Key(Key);
			cout	<<	" is not present in the database\n";
		}
	}
	else {
		cout	<<	"\nDatabase is empty\n\n";
	}
}


// PRE	TRUE
// POST	IF DataBase is not empty
//				it is printed in key order
void
Print_DataBase(BST_T DataBase) {

	if (Q_EmptyTree(DataBase)) {
		cout	<< "\n No records to print \n";
	}
	else {
		Print_Tree_R(DataBase);
	}
}


// PRE	TRUE
// POST	IF DBase is not empty
//				Tree diagram of DBase printed
//			ELSE
//				Appropriate message
void
Show_DBase_Structure(BST_T DBase) {

	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nStructure of database is \n";
		Tree_Diagram_R(DBase, 0, 1);
	}
	else {
		cout	<< "\n\nNo elements in database";
	}
}


// PRE	TRUE
// POST IF NOT Q_EmptyTree THEN
//			prints out size of tree
//		ELSE
//			empty tree message
void
Print_Size(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nSize is "
				<< Size_R(DBase)
				<< "\n";
	}
	else {
		cout	<< "\Database is empty\n";
	}
}


// PRE	TRUE
// POST IF NOT Q_EmptyTree THEN
//			prints out sum of elements in tree
//		ELSE
//			empty tree message
void
Print_Sum(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		cout	<< "\nSum of keys of elements is \n";
		Write_Key(Sum_R(DBase));
	}
	else {
		cout	<< "\Database is empty\n";
	}
}



// PRE	TRUE
// POST IF NOT Q_EmptyTree THEN
//			user is pormpted for n in range [1..Size_R(Tree)]
//			prints out sum of nth key in order from database
//		ELSE
//			empty database message
void
Print_NthKey(BST_T DBase) {
	int	n;

	if (!Q_EmptyTree(DBase)) {
		cout	<<	"\nPlease type value of n between "
				<<	"1 and "
				<<	Size_R(DBase)
				<<	" ===> ";
		cin	>> n;
		if (n > Size_R(DBase)) {
			cout	<< "\nn must be less than or equal to "
					<<	Size_R(DBase)
					<<	"\n";
		}
		else {
			if (n < 1) {
				cout	<<	"\nn must be greater than 0";
			}
			else {
				cout	<< "\n"
						<<	n
						<<	"nth key is \n";
				Write_Key(Get_NthKey_R(n, DBase));
			}
		}
	}
	else {
		cout	<< "\Database is empty\n";
	}
}


// PRE	TRUE
// POST	Prints height of database tree to screen
void
Print_Height(BST_T DBase) {

	cout	<< "\nHeight of database is "
			<< Find_Depth_R(DBase)
			<< "\n";
}



// PRE	TRUE
// POST	IF DBase is not empty
//				prints out elements inorderwise
//			ELSE
//				appropriate message
void
Do_InOrder(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		InOrder_R(DBase);
	}
	else {
		cout	<< "\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST	IF DBase is not empty
//				prints out elements preorderwise
//			ELSE
//				appropriate message
void
Do_PreOrder(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		PreOrder_R(DBase);
	}
	else {
		cout	<< "\nDatabase is empty\n";
	}
}


// PRE	TRUE
// POST	IF DBase is not empty
//				prints out elements postorderwise
//			ELSE
//				appropriate message
void
Do_PostOrder(BST_T DBase) {
	if (!Q_EmptyTree(DBase)) {
		PostOrder_R(DBase);
	}
	else {
		cout	<< "\nDatabase is empty\n";
	}
}


//	PRe	TRUE
// POST	IF DBase is not empty
//				user is prompted for two names
//				IF second name is not lexicographically less than first
//					all records with names between the input names, inclusive,
//					are printed
//				ELSE
//					message to say invalid range
//			ELSE message to say empty DBase
void
Select_By_Names(BST_T DBase) {
	char	*Name1,
			*Name2;

	if (!Q_EmptyTree(DBase)) {
		cout	<<	"Please input first name ==> ";
		Name1 = Read_String();
		cout	<<	"Please input second name ==> ";
		Name2 = Read_String();
		if (strcmp(Name1, Name2) <= 0) {
			Print_NameRange_R(DBase, Name1, Name2);
		}
		else {
			cout	<<	Name1
					<<	" comes after "
					<<	Name2;
		}
	}
	else {
		cout	<<	"\nDatabase is empty";
	}
}


// POST	IF DBase is not empty
//				user is prompted for two names
//				IF second name is not lexicographically less than first
//					all records with names between the input names, inclusive,
//					are printed
//				ELSE
//					message to say invalid range
//			ELSE message to say empty DBase
void
Tree_Select_By_Names(BST_T &AuxDBase, BST_T DBase) {
	char	*Name1,
			*Name2;

	if (!Q_EmptyTree(DBase)) {
		cout	<<	"Please input first name ==> ";
		Name1 = Read_String();
		cout	<<	"Please input second name ==> ";
		Name2 = Read_String();
		if (strcmp(Name1, Name2) <= 0) {
			AuxDBase = Make_NameRangeBST_R(DBase, Name1, Name2);
			cout	<<	"\nTree of names between "
					<< Name1
					<<	" and "
					<<	Name2
					<<	" has been created\n"
					<<	"Option 'd' to view\n";
		}
		else {
			cout	<<	Name1
					<<	" comes after "
					<<	Name2;
		}
	}
	else {
		cout	<<	"\nDatabase is empty";
	}
}


// POST	IF DBase is not empty
//				user is prompted for two names
//				IF second name is not lexicographically less than first
//					all records with names between the input names, inclusive,
//					are printed
//				ELSE
//					message to say invalid range
//			ELSE message to say empty DBase
void
Mirror_Tree(BT_T &ReflectBT, BT_T BT) {
	char Dummy;

	if (!Q_EmptyTree(BT)) {
		ReflectBT = Reflect_BT_R(BT);
		cout	<<	"\nReflection of \n";
		Show_DBase_Structure(BT);
		cout	<< "\n is - press return to continue ";
		cin.get(Dummy);
		cin.get(Dummy);
		Show_DBase_Structure(ReflectBT);
	}
	else {
		cout	<<	"\nDatabase is empty";
	}
}


// PRE	TRUE
// POST	traversal menu displayed
void
Traversal_Menu() {

	cout	<< "***   Traversal Options  	  *****************\n";
	cout	<< "***   (i)norder traversal  	  **************\n";
	cout	<< "***   pr(e)order traversal  	  **************\n";
	cout	<< "***   p(o)storder traversal  	 ************\n";
	cout	<< "***   (s)elect by names traversal ***********\n";
	cout	<< "***   (n)ames selection to make tree  *******\n";
	cout	<< "***   re(f)lect tree in auxiliary tree ******\n";
	cout	<< "***   (d)iagram of auxiliary tree  **********\n";
	cout	<< "***   p(r)int all records with brackets *****\n";
	cout	<< "***   (t)raversal menu 	  *****************\n";
	cout	<< "***   e(x)it to main menu	  	****************\n";
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		for traversal options
//		until 'x' is the character read
void
Traversals(BST_T DBase) {

	char 	Request;
	static int	RequestCount = 0;
	BST_T	AuxDBase;

	AuxDBase = Create_Tree();

	for (Request = 'm'; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'i' : Do_InOrder(DBase);
				break;
			case 'e' : Do_PreOrder(DBase);
				break;
			case 'o' : Do_PostOrder(DBase);
				break;
			case 's' : Select_By_Names(DBase);
				break;
			case 'n'	: Tree_Select_By_Names(AuxDBase, DBase);
				break;
			case 'f'	: Mirror_Tree(AuxDBase, DBase);
				break;
			case 'r' : Print_DataBase(DBase);
				break;
			case 'd'	: cout	<< "\nAuxiliary data base of selected names is as follows\n";
						  Show_DBase_Structure(AuxDBase);
				break;
			case 'm' : Traversal_Menu();
				break;
			default   : cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext traversal request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;

	}
}



// PRE	TRUE
// POST	menu displayed
void
Menu() {

	cout	<< "***   Main Menu            	  **************\n";
	cout	<< "***   (a)dd a new record  	  **************\n";
	cout	<< "***   check (k)ey present  	  **************\n";
	cout	<< "***   (g)et record         	  **************\n";
	cout	<< "***   (e)rase record       	  **************\n";
	cout	<< "***   print (s)ize of database **************\n";
	cout	<< "***   print s(u)m of keys in database      **\n";
	cout	<< "***   print nth ke(y) in database      ******\n";
	cout	<< "***   show (d)iagram of database  ***********\n";
	cout	<< "***   print (h)eight of database  ***********\n";
	cout	<< "***   print (n)odes allocated so far ********\n";
	cout	<< "***   show LR path for (p)ath and length  ***\n";
	cout	<< "***   (l)oad database from file  ************\n";
	cout	<< "***   sa(v)e database to file  **************\n";
	cout	<< "***   (t)raversal options  ******************\n";
	cout	<< "***   (r)eset database **********************\n";
	cout	<< "***   this (m)enu	       	****************\n";
	cout	<< "***   e(x)it			        	****************\n";
}


// PRE	TRUE
// POST	DBase initialised
void
Initialise(BST_T &DBase) {

	DBase = Create_Tree();
}


// PRE	TRUE
// POST Goes into a prompt, read and execute cycle
//		until 'x' is the character read
void
Loop(BST_T DBase) {

	char 	Request;
	int	RequestCount;

	for (Request = 'm', RequestCount = 0; Request != 'x'; RequestCount++) {

		switch(Request) {

			case 'a': Add_New_Record(DBase);
				break;
			case 'k': Check_Key_Present(DBase);
				break;
			case 'g': Get_Record(DBase);
				break;
			case 'e': Erase_Record(DBase);
				break;
			case 's': Print_Size(DBase);
				break;
			case 'u': Print_Sum(DBase);
				break;
			case 'y': Print_NthKey(DBase);
				break;
			case 'l': Load_Tree_From_File(DBase);
				break;
			case 'v': Save_Tree_To_File(DBase);
				break;
			case 'd': Show_DBase_Structure(DBase);
				break;
			case 'p': Show_Path();
				break;
			case 'h': Print_Height(DBase);
				break;
			case 'n': cout	<<	"\nNumber of nodes allocated is "
								<<	Get_NumberNodes_Allocated();
				break;
			case 'r': Initialise(DBase);
				break;
			case 't' : Traversals(DBase);
				break;
			case 'm' : Menu();
				break;
			default   : cout	<< "\n m for menu \n";
		}
		cout	<< "\n\nNext request ["
				<< RequestCount
				<< "] ==> ";
		cin	>> Request;

	}
}


// PRE	TRUE
// POST	Clears up
void
Finalise(BST_T DBase) {
	cout	<< "That is it !";
}


void
main () {
	Initialise(DataBase);
	Loop(DataBase);
	Finalise(DataBase);
}