// data.h
// 8/8/98
// character records for demonstrating stack
// Ken Brownsey

#ifndef DATA_H
#define DATA_H

#include <fstream.h>
#include "my_const.h"

#define NumClubs	5
#define FirstClub	Diogenes
#define LastClub (NumClubs - 1)


typedef int	Number_T;

typedef struct {
	int	Day,
			Month,
			Year;
} Date_T;

typedef enum {Diogenes, Drones, Runagates, HellFire, Tufty, NoClub} Club_T;

typedef BOOLEAN	Clubs_T[NumClubs];


typedef struct {
	Number_T	Number;
	char	*Name;
	Date_T	Date;
	Clubs_T	Clubs;
	BOOLEAN	Q_OnWaitingList;
} DataRec_T;




// PRE	TRUE
// POST	user is prompted for student key value which is returned
Number_T
Read_Number();


// PRE	TRUE
// POST	key value is written to screen
void
Write_Number(Number_T Number);


// PRE	TRUE
// POST	returnS key value of Rec
Number_T
Get_Number(DataRec_T DataRec);


// PRE	TRUE
// POST	returnS Name value of Rec
char
*Get_Name(DataRec_T DataRec) ;


//	PRE	TRUE
//	POST	prompts user for DDMMYY date
//			which is read into Date
void
Read_Date(Date_T &Date);


//	PRE	TRUE
//	POST	writes Rec to screen
void
Write_Date(Date_T Date);


//	PRE	TRUE
//	POST	RETURNS Date from DataRec
Date_T
Get_Date(DataRec_T DataRec);


// PRE	TRUE
// POST	Prompts user for club by number
//		and returns mode club in defaulting to NoClub */
Club_T
Read_Club();


//	PRE	TRUE
//	POST	IF Club is valid
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
Q_ValidClub(Club_T Club);



//	PRE	TRUE
//	POST	IF Club has a TRUE entry in Clubs
//				RETURNS(TRUE)
//			ELSE
//				RETURNS(FALSE)
BOOLEAN
Q_Member_Of_Club(Club_T Club, DataRec_T Rec);


// PRE	Club has a valid value
// POST	Prints string for Club
void
Write_Club(Club_T Club);


//	PRE	Club != NoClub
//	POST	Club has a TRUE entry in Clubs filed of Record
void
Set_Club(Club_T Club, DataRec_T &Record);


//	PRE	Club != NoClub
//	POST	Club has a FALSE entry in Clubs filed of Record
void
UnSet_Club(Club_T Club, DataRec_T &Record);


//	PRE	TRUE
//	POST	All members of Clubs which have TRUE entries are printed
void
Write_Clubs(Clubs_T Clubs);


//	PRE	TRUE
//	POST	prompts user for applicant record
//			which is read into Rec
void
Read_Rec(DataRec_T &Rec);


//	PRE	TRUE
//	POST	writes Rec to screen
void
Write_Rec(DataRec_T Rec);


// PRE	FileHandle is a correctly opened stream
// POST	IF record read from file OK THEN
//				returnS record read
//				Q_ValidRecFromFile' = TRUE
//			ELSE
//				Q_ValidRecFromFile' = FALSE
DataRec_T
Read_Rec_From_File(ifstream &InFile, BOOLEAN &Q_ValidRecFromFile);



// PRE	FileHandle is a correctly opened stream
// POST	Rec written to FileHandle stream
void
Write_DataRec_To_File (DataRec_T Rec, ofstream &OutFile);


//	PRE	TRUE
// POST	IF Date1 precedes Date2
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Date_Before(Date_T	Date1, Date_T	Date2);

//	PRE	TRUE
// POST	IF Date1 equals Date2
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_Dates_Equal(Date_T	Date1, Date_T	Date2);


#endif
