// stack.cpp
// 7/8/98
// Queue_T based on Queue_T
// Ken Brownsey

#include "queue.h"

typedef struct Node_Tag {
	struct Node_Tag		*Next_Ptr;
	Element_T		Element;
} Node_T, *Node_Ptr_T;


typedef struct {
	Node_Ptr_T	Head,
					Tail;
}	QuRec_T, *QuRec_Ptr_T;


// PRE	TRUE
// POST	RETURNS an initialised Queue_T
Queue_T
Create_Queue() {
	QuRec_Ptr_T NewQu;

	NewQu = new QuRec_T;
	NewQu->Head = NULL;
	NewQu->Tail = NULL;
	return((Queue_T) NewQu);
}


// PRE	NOT Q_FullQueue(Queue)
// POST 	elements of Queue' = elements of Queue union {Element}
void
EnQueue(Element_T NewElement, Queue_T Queue) {
	QuRec_Ptr_T Qu;
	Node_Ptr_T	NewNode_Ptr;

	Qu = (QuRec_Ptr_T) Queue;
	NewNode_Ptr = new Node_T;
	NewNode_Ptr->Element = NewElement;
	NewNode_Ptr->Next_Ptr = NULL;
	if (Qu->Head == NULL) {
		Qu->Head = NewNode_Ptr;
	}
	else {
		Qu->Tail->Next_Ptr = NewNode_Ptr;
	}
	Qu->Tail = NewNode_Ptr;
}


// PRE	TRUE
// POST	IF Queue is empty
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_EmptyQueue(Queue_T Queue) {
	QuRec_Ptr_T Qu;

	Qu = (QuRec_Ptr_T) Queue;
	return(Qu->Head == NULL);
}


// PRE	TRUE
// POST	IF Queue is full
//				RETURNS TRUE
//			ELSE
//				RETURNS FALSE
BOOLEAN
Q_FullQueue(Queue_T Queue) {
	return(FALSE);
}


// PRE	NOT Q_EmptyQueue(Queue)
// POST	Queue' is Queue with the earliest entered
//			element removed
void
DeQueue(Queue_T Queue) {
	QuRec_Ptr_T Qu;
	Node_Ptr_T	Temp;

	Qu = (QuRec_Ptr_T) Queue;
	Temp = Qu->Head;
	Qu->Head = Qu->Head->Next_Ptr;
	if (Qu->Head == NULL) {
		Qu->Tail = NULL;
	}
	delete Temp;
}


// PRE	NOT Q_EmptyQueue(Queue)
// POST	RETURNS the value of the earliest
//				entered element of Queue *)
Element_T
Front(Queue_T Queue) {
	QuRec_Ptr_T Qu;

	Qu = (QuRec_Ptr_T) Queue;
	return(Qu->Head->Element);
}


//	PRE	Q_EmptyQueue(Queue)
//	POST	all memory allocated to Queue is freed up
// NOTES	Queue will need to be re-initialised
//			with Create_Queue() before being used again
void
Free_Queue(Queue_T Queue) {
	QuRec_Ptr_T Qu;

	Qu = (QuRec_Ptr_T) Queue;
	delete Qu;
}

